/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
import { XYChart } from "./XYChart";
import { typeCast, runOn, delegateCombine, enumGetBox, markType, TypeRegistrar, getInstanceType } from "igniteui-angular-core/ES2015/type";
import { CategoryChartType_$type } from "./CategoryChartType";
import { CategorySeriesMarkerCollisionAvoidance_$type } from "./CategorySeriesMarkerCollisionAvoidance";
import { CategoryTransitionInMode_$type } from "./CategoryTransitionInMode";
import { TransitionInSpeedType_$type } from "./TransitionInSpeedType";
import { CategoryXAxis } from "./CategoryXAxis";
import { List$1 } from "igniteui-angular-core/ES2015/List$1";
import { DataSeriesType_$type } from "igniteui-angular-core/ES2015/DataSeriesType";
import { NumericYAxis } from "./NumericYAxis";
import { IDataSeriesAdapterRule_$type } from "igniteui-angular-core/ES2015/IDataSeriesAdapterRule";
import { SimpleCategorySeriesRule } from "igniteui-angular-core/ES2015/SimpleCategorySeriesRule";
import { SubCollectionsRule } from "igniteui-angular-core/ES2015/SubCollectionsRule";
import { Series } from "./Series";
import { HorizontalAnchoredCategorySeries } from "./HorizontalAnchoredCategorySeries";
import { ArrayExtension } from "igniteui-angular-core/ES2015/ArrayExtension";
import { Brush } from "igniteui-angular-core/ES2015/Brush";
import { AxisLabelSettings } from "./AxisLabelSettings";
import { stringIsNullOrEmpty } from "igniteui-angular-core/ES2015/string";
export class CategoryChart extends XYChart {
    constructor() {
        super();
        this.pz = 1000;
        this.o3 = null;
        this.on = 9;
        this.op = 1;
        this.o7 = false;
        this.or = 0;
        this.o1 = 0;
        this.pg = 0;
        this.ph = 0;
        this.pf = 0;
        this.pi = 0;
        this.pj = NaN;
        this.o9 = false;
        this.p0 = 10;
        this.pl = NaN;
        this.pk = NaN;
        this.pm = 0;
        this.oj = null;
        this.ok = null;
        this.o8 = true;
        this.o5 = false;
        this.o6 = false;
        this.f4();
    }
    gh() {
        super.gh();
        if (this.dataChart == null) {
            return;
        }
        let a = this.dataChart.bm.i.e();
        this.ol = a.d;
        this.om = a.e;
        if (this.nv == null) {
            this.nv = a.k;
        }
        if (this.n2 == null) {
            this.n2 = a.k;
        }
    }
    gj(a, b) {
        super.gj(a, b);
        a.ff = this.p1;
        a.bv = this.o4;
    }
    g0(a, b, c) {
        super.g0(a, b, c);
        switch (a) {
            case "TransitionInDuration":
                this.qq((d) => d.ff = this.p1);
                break;
            case "TransitionInEasingFunction":
                this.qq((d) => d.bv = this.o4);
                break;
        }
    }
    get p1() {
        return this.pz;
    }
    set p1(a) {
        let b = this.p1;
        if (a != b) {
            this.pz = a;
            this.gz("TransitionInDuration", b, this.p1);
        }
    }
    get o4() {
        return this.o3;
    }
    set o4(a) {
        let b = this.o4;
        if (a != b) {
            this.o3 = a;
            this.gz("TransitionInEasingFunction", b, this.o4);
        }
    }
    p4() {
        let cvd_ = this.di();
        cvd_.scaleByViewport();
        return (cvd_.serialize());
    }
    gc(a) {
        super.gc(a);
        a.cc = this.be;
    }
    gi(a, b) {
        super.gi(a, b);
        let c = typeCast(HorizontalAnchoredCategorySeries.$, a);
        if (c == null) {
            return;
        }
        c.or = this.oq;
        c.np = this.pc;
        c.m8 = this.os;
        c.bp = this.o2;
        c.trendLineBrush = ArrayExtension.getModulus$1(Brush.$, this.o, b);
        c.trendLineType = this.av;
        c.trendLineThickness = this.c5;
        c.ls = this.ai(a, b);
        if (a.cz) {
            a.i9(ArrayExtension.getModulus$1(Brush.$, this.ol, b), ArrayExtension.getModulus$1(Brush.$, this.om, b));
        }
    }
    ot() {
        return new CategoryXAxis();
    }
    ox() {
        return new NumericYAxis();
    }
    f2() {
        this.xAxis = this.ot();
        this.xAxis.name = "xAxis";
        let a = this.xAxis;
        a.propertyChanged = delegateCombine(a.propertyChanged, runOn(this, this.qs));
        this.yAxis = this.ox();
        this.yAxis.name = "yAxis";
        let b = this.yAxis;
        b.propertyChanged = delegateCombine(b.propertyChanged, runOn(this, this.qt));
        if (this.xAxis.aw == null) {
            this.xAxis.aw = new AxisLabelSettings();
        }
        if (this.yAxis.aw == null) {
            this.yAxis.aw = new AxisLabelSettings();
        }
    }
    m1(a) {
        super.m1(a);
        a.jh = this.pd;
    }
    get oo() {
        return this.on;
    }
    set oo(a) {
        if (a != this.on) {
            let b = this.oo;
            this.on = a;
            this.gz("ChartType", enumGetBox(CategoryChartType_$type, b), enumGetBox(CategoryChartType_$type, this.oo));
        }
    }
    get oq() {
        return this.op;
    }
    set oq(a) {
        let b = this.oq;
        if (a != b) {
            this.op = a;
            this.gz("MarkerCollisionAvoidance", enumGetBox(CategorySeriesMarkerCollisionAvoidance_$type, b), enumGetBox(CategorySeriesMarkerCollisionAvoidance_$type, this.oq));
        }
    }
    get pc() {
        return this.o7;
    }
    set pc(a) {
        let b = this.pc;
        if (a != b) {
            this.o7 = a;
            this.gz("IsTransitionInEnabled", b, this.pc);
        }
    }
    get os() {
        return this.or;
    }
    set os(a) {
        let b = this.os;
        if (a != b) {
            this.or = a;
            this.gz("TransitionInMode", enumGetBox(CategoryTransitionInMode_$type, b), enumGetBox(CategoryTransitionInMode_$type, this.os));
        }
    }
    get o2() {
        return this.o1;
    }
    set o2(a) {
        let b = this.o2;
        if (a != b) {
            this.o1 = a;
            this.gz("TransitionInSpeedType", enumGetBox(TransitionInSpeedType_$type, b), enumGetBox(TransitionInSpeedType_$type, this.o2));
        }
    }
    get pq() {
        return this.pg;
    }
    set pq(a) {
        let b = this.pq;
        if (a != b) {
            this.pg = a;
            this.gz("XAxisInterval", b, this.pq);
        }
    }
    get pr() {
        return this.ph;
    }
    set pr(a) {
        let b = this.pr;
        if (a != b) {
            this.ph = a;
            this.gz("XAxisMinorInterval", b, this.pr);
        }
    }
    get pp() {
        return this.pf;
    }
    set pp(a) {
        let b = this.pp;
        if (a != b) {
            this.pf = a;
            this.gz("XAxisGap", b, this.pp);
        }
    }
    get ps() {
        return this.pi;
    }
    set ps(a) {
        let b = this.ps;
        if (a != b) {
            this.pi = a;
            this.gz("XAxisOverlap", b, this.ps);
        }
    }
    get pv() {
        return this.pj;
    }
    set pv(a) {
        let b = this.pv;
        if (a != b) {
            this.pj = a;
            this.gz("YAxisInterval", b, this.pv);
        }
    }
    get pe() {
        return this.o9;
    }
    set pe(a) {
        let b = this.pe;
        if (a != b) {
            this.o9 = a;
            this.gz("YAxisIsLogarithmic", b, this.pe);
        }
    }
    get p2() {
        return this.p0;
    }
    set p2(a) {
        let b = this.p2;
        if (a != b) {
            this.p0 = a;
            this.gz("YAxisLogarithmBase", b, this.p2);
        }
    }
    get px() {
        return this.pl;
    }
    set px(a) {
        let b = this.px;
        if (a != b) {
            this.pl = a;
            this.gz("YAxisMinimumValue", b, this.px);
        }
    }
    get pw() {
        return this.pk;
    }
    set pw(a) {
        let b = this.pw;
        if (a != b) {
            this.pk = a;
            this.gz("YAxisMaximumValue", b, this.pw);
        }
    }
    get py() {
        return this.pm;
    }
    set py(a) {
        let b = this.py;
        if (a != b) {
            this.pm = a;
            this.gz("YAxisMinorInterval", b, this.py);
        }
    }
    get po() {
        return this.xAxis.k4;
    }
    get pn() {
        return this.xAxis.k3;
    }
    get pu() {
        return this.yAxis.jx;
    }
    get pt() {
        return this.yAxis.jw;
    }
    get ol() {
        return this.oj;
    }
    set ol(a) {
        let b = this.ol;
        if (a != b) {
            this.oj = a;
            this.gz("NegativeBrushes", b, this.ol);
        }
    }
    get om() {
        return this.ok;
    }
    set om(a) {
        let b = this.om;
        if (a != b) {
            this.ok = a;
            this.gz("NegativeOutlines", b, this.om);
        }
    }
    get pd() {
        return this.o8;
    }
    set pd(a) {
        let b = this.pd;
        if (a != b) {
            this.o8 = a;
            this.gz("YAxisAbbreviateLargeNumbers", b, this.pd);
        }
    }
    get pa() {
        return this.o5;
    }
    set pa(a) {
        let b = this.pa;
        if (a != b) {
            this.o5 = a;
            this.gz("IsCategoryHighlightingEnabled", b, this.pa);
        }
    }
    get pb() {
        return this.o6;
    }
    set pb(a) {
        let b = this.pb;
        if (a != b) {
            this.o6 = a;
            this.gz("IsItemHighlightingEnabled", b, this.pb);
        }
    }
    get_b3() {
        let a = new List$1(DataSeriesType_$type, 0);
        if (TypeRegistrar.isRegistered("AreaSeries")) {
            a.add(2);
        }
        if (TypeRegistrar.isRegistered("ColumnSeries")) {
            a.add(1);
        }
        if (TypeRegistrar.isRegistered("LineSeries")) {
            a.add(0);
        }
        if (TypeRegistrar.isRegistered("PointSeries")) {
            a.add(10);
        }
        if (TypeRegistrar.isRegistered("SplineSeries")) {
            a.add(6);
        }
        if (TypeRegistrar.isRegistered("SplineAreaSeries")) {
            a.add(7);
        }
        if (TypeRegistrar.isRegistered("StepAreaSeries")) {
            a.add(5);
        }
        if (TypeRegistrar.isRegistered("StepLineSeries")) {
            a.add(4);
        }
        if (TypeRegistrar.isRegistered("WaterfallSeries")) {
            a.add(8);
        }
        return a;
    }
    get b3() {
        return this.get_b3();
    }
    qs(a, b) {
        switch (b.propertyName) {
            case "ActualMinimum":
                this.g6("XAxisActualMinimum");
                break;
            case "ActualMaximum":
                this.g6("XAxisActualMaximum");
                break;
        }
    }
    qt(a, b) {
        switch (b.propertyName) {
            case "ActualMinimumValue":
                this.g6("YAxisActualMinimum");
                break;
            case "ActualMaximumValue":
                this.g6("YAxisActualMaximum");
                break;
        }
    }
    hh() {
        super.hh();
        this.xAxis.e2 = this.kl == null ? XYChart.kt(this.xAxis, this.v.dataSeries) : this.kl;
        this.xAxis.itemsSource = this.dataChart != null && this.dataChart.series.count > 0 ? this.dataChart.series._inner[0].itemsSource : null;
    }
    get xAxis() {
        return this._xAxis;
    }
    set xAxis(a) {
        this._xAxis = a;
    }
    get yAxis() {
        return this._yAxis;
    }
    set yAxis(a) {
        this._yAxis = a;
    }
    ow(a, b) {
        switch (a) {
            case 2: return this.ar(1);
            case 3: return this.ar(10);
            case 0: return this.ar(0);
            case 1: return this.ar(2);
            case 6: return this.ar(6);
            case 7: return this.ar(7);
            case 4: return this.ar(4);
            case 5: return this.ar(5);
            case 8: return this.ar(8);
            case 9: return this.ov(b);
            default: return this.ar(1);
        }
    }
    ov(a) {
        return this.ar(a);
    }
    u(a) {
        switch (this.oo) {
            case 1: return 2;
            case 0: return 0;
            case 3: return 10;
            case 6: return 6;
            case 7: return 7;
            case 5: return 5;
            case 4: return 4;
            case 8: return 8;
            case 9: return a.suggestedSeries;
            default:
            case 2: return 1;
        }
    }
    aq(a, b) {
        let c = this.ow(this.oo, a.suggestedSeries);
        c.o4 = a.findMatchingHint(0).path;
        c.xAxis = this.xAxis;
        c.yAxis = this.yAxis;
        return c;
    }
    hf(a) {
        if (a.suggestedSecondaryAxis == 2) {
            this.yAxis.jm = true;
            this.yAxis.j9 = 10;
        }
    }
    hi() {
        this.yAxis.jm = this.pe;
        this.yAxis.j9 = this.p2;
    }
    get_b2() {
        return ((() => {
            let $ret = new List$1(IDataSeriesAdapterRule_$type, 0);
            $ret.add(new SimpleCategorySeriesRule());
            $ret.add(new SubCollectionsRule());
            return $ret;
        })());
    }
    get b2() {
        return this.get_b2();
    }
    f0(a, b) {
        let c = typeCast(HorizontalAnchoredCategorySeries.$, a);
        if (c != null) {
            c.or = this.oq;
            c.ls = this.ai(a, b);
        }
    }
    qq(a) {
        this.qr((b, c) => a(b));
    }
    qr(a) {
        if (this.dataChart == null) {
            return;
        }
        for (let b = 0; b < this.dataChart.series.count; b++) {
            let c = typeCast(HorizontalAnchoredCategorySeries.$, this.dataChart.series._inner[b]);
            if (c == null) {
                continue;
            }
            a(c, b);
        }
    }
    h5() {
        return this.xAxis;
    }
    h6() {
        return this.yAxis;
    }
    oz() {
        return this.ar(30);
    }
    o0() {
        return this.ar(31);
    }
    bz(a, b) {
        let c = super.bz(a, b);
        if (c != null) {
            let d = new List$1(Series.$, 0);
            if (this.o5) {
                d.add(this.oz());
            }
            if (this.o6) {
                d.add(this.o0());
            }
            for (let e = 0; e < d.count; e++) {
                let f = d._inner[e];
                f.name = a + getInstanceType(f).typeName;
                c.add(f);
            }
        }
        return c;
    }
    hm(a, b, c) {
        super.hm(a, b, c);
        if (this.v.dataSeries.count > 0) {
            if (stringIsNullOrEmpty(this.d9)) {
                this.ac.setXMemberPath(a, c.getMemberPathFor(16));
            }
            if (stringIsNullOrEmpty(this.eb)) {
                this.ac.setYMemberPath(a, c.getMemberPathFor(0));
            }
            if (stringIsNullOrEmpty(this.d5)) {
                this.ac.setLabelMemberPath(a, c.getMemberPathFor(0));
            }
            if (stringIsNullOrEmpty(this.d2)) {
                this.ac.setContentMemberPath(a, c.getMemberPathFor(0));
            }
        }
    }
    gz(a, b, c) {
        super.gz(a, b, c);
        switch (a) {
            case "ChartType":
                this.hh();
                break;
            case "MarkerCollisionAvoidance":
                this.qq((d) => d.or = this.oq);
                break;
            case "IsTransitionInEnabled":
                this.qq((d) => d.np = this.pc);
                break;
            case "TransitionInMode":
                this.qq((d) => d.m8 = this.os);
                break;
            case "TransitionInSpeedType":
                this.qq((d) => d.bp = this.o2);
                break;
            case "XAxisInterval":
                this.xAxis.kz = this.pq;
                break;
            case "XAxisMinorInterval":
                this.xAxis.k0 = this.pr;
                break;
            case "XAxisGap":
                this.xAxis.jh = this.pp;
                break;
            case "XAxisOverlap":
                this.xAxis.jo = this.ps;
                break;
            case "YAxisInterval":
                this.yAxis.j1 = this.pv;
                break;
            case "YAxisIsLogarithmic":
                this.yAxis.jm = this.pe;
                break;
            case "YAxisLogarithmBase":
                this.yAxis.j9 = this.p2;
                break;
            case "YAxisMinimumValue":
                this.yAxis.j5 = this.px;
                break;
            case "YAxisMaximumValue":
                this.yAxis.j4 = this.pw;
                break;
            case "YAxisMinorInterval":
                this.yAxis.j6 = this.py;
                break;
            case "NegativeBrushes":
            case "NegativeOutlines":
                this.qr((d, e) => {
                    if (d.cz) {
                        d.i9(ArrayExtension.getModulus$1(Brush.$, this.ol, e), ArrayExtension.getModulus$1(Brush.$, this.om, e));
                    }
                });
                break;
            case "YAxisAbbreviateLargeNumbers":
                this.m7((d) => d.jh = this.pd);
                break;
            case "IsCategoryHighlightingEnabled":
            case "IsItemHighlightingEnabled":
                this.hh();
                break;
        }
    }
}
CategoryChart.$t = markType(CategoryChart, 'CategoryChart', XYChart.$);
//# sourceMappingURL=CategoryChart.js.map