/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
import { EventEmitter, Output, TemplateRef, Input } from '@angular/core';
import { Visibility, Visibility_$type } from "igniteui-angular-core/ES2015/Visibility";
import { TransitionInSpeedType, TransitionInSpeedType_$type } from './TransitionInSpeedType';
import { SeriesHitTestMode, SeriesHitTestMode_$type } from './SeriesHitTestMode';
import { brushToString, stringToBrush, toPoint, fromPoint, fromRect, stringToColor, colorToString, ensureEnum, ensureBool } from "igniteui-angular-core/ES2015/componentUtil";
import { RenderRequestedEventArgs } from './RenderRequestedEventArgs';
import { delegateCombine, TypeRegistrar } from "igniteui-angular-core/ES2015/type";
export const IgxSeriesComponent_PROVIDERS = [];
/**
 * Represents the base class for all IgxDataChartComponent series.
*/
export class IgxSeriesComponent {
    constructor() {
        this._chartLevelData = null;
        this._dataSource = null;
        this._tooltipTemplate = null;
        this._tooltipContent = null;
        this._tooltipContainerTemplate = null;
        this._renderer = null;
        this._renderRequested = null;
        this._zoneRunner = null;
        this._implementation = this.createImplementation();
        this._implementation.externalObject = this;
        this.onImplementationCreated();
    }
    get i() {
        return this._implementation;
    }
    onImplementationCreated() {
    }
    createImplementation() {
        return null;
    }
    get seriesInternal() {
        return this.i;
    }
    ngOnInit() {
    }
    set name(value) {
        this.i.name = value;
    }
    get name() {
        return this.i.name;
    }
    provideData(data) {
        this._chartLevelData = data;
        this.updateDataSource();
    }
    updateDataSource() {
        if (this._dataSource == null) {
            this.i.itemsSource = this._chartLevelData;
        }
        else {
            this.i.itemsSource = this._dataSource;
        }
    }
    set dataSource(value) {
        this._dataSource = value;
        this.updateDataSource();
        //console.log("setting axis data source: " + value)
    }
    get dataSource() {
        if (this._dataSource != null) {
            return this._dataSource;
        }
        return this.i.itemsSource;
    }
    bindAxes(axes) {
    }
    set tooltipTemplate(value) {
        this._tooltipTemplate = value;
        if (value == null) {
            if (this._tooltipContent !== null) {
                this._tooltipContent.destroy();
                this._tooltipContent = null;
            }
        }
        if (this._tooltipContent != null) {
            this._tooltipContent.instance.template = this._tooltipTemplate;
        }
        else {
            if (this.owner != null) {
                this.owner._ensureTooltipCreated(this);
            }
        }
    }
    get tooltipTemplate() {
        return this._tooltipTemplate;
    }
    set tooltipContainerTemplate(value) {
        this._tooltipContainerTemplate = value;
        if (this._tooltipContent != null) {
            this._tooltipContent.instance.containerTemplate = this._tooltipContainerTemplate;
        }
    }
    get tooltipContainerTemplate() {
        return this._tooltipContainerTemplate;
    }
    _ensureTooltipCreated(createTooltip, createWrapper) {
        if (this._tooltipTemplate == null) {
            this.i.toolTip = null;
        }
        if (this._tooltipContent == null && this._tooltipTemplate != null) {
            let tooltip = createTooltip();
            if (tooltip == null) {
                return;
            }
            this._tooltipContent = tooltip;
            tooltip.instance.template = this._tooltipTemplate;
            this.i.toolTip = createWrapper(tooltip.location.nativeElement);
        }
    }
    _ensureTooltipDestroyed() {
        if (this._tooltipContent !== null) {
            this._tooltipContent.destroy();
            this._tooltipContent = null;
        }
    }
    _provideRenderer(renderer) {
        this._renderer = renderer;
        this._zoneRunner = (act) => renderer._ngZone.run(act);
    }
    static _createFromInternal(internal) {
        if (!internal) {
            return null;
        }
        if (!internal.$type) {
            return null;
        }
        let name = internal.$type.name;
        let externalName = "Igx" + name + "Component";
        if (!TypeRegistrar.isRegistered(externalName)) {
            return null;
        }
        return TypeRegistrar.create(externalName);
    }
    /**
         * Gets whether the series is an annotation layer.
        */
    get isAnnotationLayer() {
        return this.i.cj;
    }
    /**
         * Gets whether the current series is oriented vertically.
        */
    get isVertical() {
        return this.i.isVertical;
    }
    /**
         * Gets whether the current series is a stack fragment.
        */
    get isFragment() {
        return this.i.cs;
    }
    /**
         * Gets whether the current series shows an area or line shape.
        */
    get isAreaOrLine() {
        return this.i.ck;
    }
    /**
         * Gets whether the current series is a polar type series.
        */
    get isPolar() {
        return this.i.c0;
    }
    /**
         * Gets whether the current series is a scatter type series.
        */
    get isScatter() {
        return this.i.c4;
    }
    /**
         * Gets whether the current series is a radial type series.
        */
    get isRadial() {
        return this.i.c2;
    }
    /**
         * Gets whether the current series is a stacked type series.
        */
    get isStacked() {
        return this.i.isStacked;
    }
    /**
         * Gets whether the current series is a financial type series.
        */
    get isFinancial() {
        return this.i.cr;
    }
    /**
         * Gets whether the current series is a range type series.
        */
    get isRange() {
        return this.i.c3;
    }
    /**
         * Gets whether the current series is a category type series.
        */
    get isCategory() {
        return this.i.cl;
    }
    /**
         * Gets whether the current seires is a geogrpahic series.
        */
    get isGeographic() {
        return this.i.ct;
    }
    /**
         * Gets whether the default crosshair behavior should be disabled if this series is present.
        *
        * `isDefaultCrosshairBehaviorDisabled` defaults to true for annotation layers. When not using annotaion layers, you can show crosshairs by setting the chart's `IgxSeriesComponent` to true.
        */
    get isDefaultCrosshairBehaviorDisabled() {
        return this.i.cm;
    }
    /**
         * Gets whether the default tooltip behavior should be disabled if this series is present.
        */
    get isDefaultTooltipBehaviorDisabled() {
        return this.i.cn;
    }
    /**
         * Returns whether the current series supports visual markers.
        */
    get hasMarkers() {
        return this.i.hasMarkers;
    }
    /**
         * Gets if the series uses an index, which can be used to auto-assign it a color.
        */
    get isIndexed() {
        return this.i.cw;
    }
    /**
         * Gets if the series should appear in any legends.
        */
    get isUsableInLegend() {
        return this.i.isUsableInLegend;
    }
    /**
         * Gets or sets the legend item visibility for the current series object.
        *
        * The `IgxSeriesComponent` can be used to exclude only certain `IgxSeriesComponent` from the `IgxSeriesComponent`.
        */
    get legendItemVisibility() {
        return this.i.lq;
    }
    set legendItemVisibility(v) {
        this.i.lq = ensureEnum(Visibility_$type, v);
    }
    /**
         * Gets or sets the LegendItemBadgeTemplate property.
         * The legend item badge is created according to the LegendItemBadgeTemplate on-demand by
         * the series object itself.
        *
        * The `legendItemBadgeTemplate` is used to describe the visual structure of the badge icon for each legend item.
        */
    get legendItemBadgeTemplate() {
        return this.i.legendItemBadgeTemplate;
    }
    set legendItemBadgeTemplate(v) {
        this.i.legendItemBadgeTemplate = v;
    }
    /**
         * Gets or sets the LegendItemTemplate property.
         * The legend item control content is created according to the LegendItemTemplate on-demand by
         * the series object itself.
        *
        * The `legendItemTemplate` is used to describe the visual structure of each legend item in the `IgxSeriesComponent`.
        */
    get legendItemTemplate() {
        return this.i.legendItemTemplate;
    }
    set legendItemTemplate(v) {
        this.i.legendItemTemplate = v;
    }
    /**
         * Gets or sets the DiscreteLegendItemTemplate property.
         * The legend item control content is created according to the DiscreteLegendItemTemplate on-demand by
         * the series object itself.
        *
        * The legend item control content is created according to the DiscreteLegendItemTemplate on-demand by the series object itself
        */
    get discreteLegendItemTemplate() {
        return this.i.jp;
    }
    set discreteLegendItemTemplate(v) {
        this.i.jp = v;
    }
    /**
         * Gets or sets the easing function used to morph the current series.
        *
        * The `IgxSeriesComponent` and `transitionEasingFunction` can be used to play animation when data is added or removed from a `IgxSeriesComponent`. To play an initial animation see `transitionInDuration`.
        */
    get transitionEasingFunction() {
        return this.i.bu;
    }
    set transitionEasingFunction(v) {
        this.i.bu = v;
    }
    /**
         * Gets or sets the EasingFunction used to morph the current series during the initial transition.
        *
        * The `transitionInEasingFunction` can be used with `IgxSeriesComponent` to cofigure the animation when a new datasource is loaded.
        */
    get transitionInEasingFunction() {
        return this.i.bv;
    }
    set transitionInEasingFunction(v) {
        this.i.bv = v;
    }
    /**
         * Gets or sets the duration of the current series's morph.
        *
        * The `transitionDuration` can be used to play animation when data is added or removed from a `IgxSeriesComponent`. To play an initial animation see `transitionInDuration`.
        *
        * ```html
        * <igx-data-chart
        *     [dataSource]="data"
        *     animateSeriesWhenAxisRangeChanges=true>
        *     <igx-category-x-axis
        *         label="label"
        *         #xAxis>
        *     </igx-category-x-axis>
        *     <igx-numeric-y-axis
        *         #yAxis>
        *     </igx-numeric-y-axis>
        *     <igx-column-series
        *         [xAxis]="xAxis"
        *         [yAxis]="yAxis"
        *         valueMemberPath="value"
        *         transitionInMode="accordionFromBottom"
        *         isTransitionInEnabled=true
        *         transitionInSpeedType="indexScaled"
        *         transitionDuration=500
        *         transitionInDuration=500>
        *     </igx-column-series>
        * </igx-data-chart>
        * ```
        */
    get transitionDuration() {
        return this.i.fe;
    }
    set transitionDuration(v) {
        this.i.fe = +v;
    }
    /**
         * Gets or sets the current series object's rendering resolution.
        *
        * Setting the `resolution` on a Series to a higher value can help with performance, but it will lower the graphical fidelity of the line. As such, it can be increased up until the fidelity is unacceptable.
        *
        * ```html
        *  <igx-data-chart
        *     [dataSource]="data">
        *     <igx-category-x-axis
        *         label="label"
        *         #xAxis>
        *     </igx-category-x-axis>
        *     <igx-numeric-y-axis
        *         #yAxis>
        *     </igx-numeric-y-axis>
        *     <igx-line-series
        *         [xAxis]="xAxis"
        *         [yAxis]="yAxis"
        *         valueMemberPath="value"
        *         resolution=1.5>
        *     </igx-line-series>
        * </igx-data-chart>
        * ```
        *
        *
        */
    get resolution() {
        return this.i.eq;
    }
    set resolution(v) {
        this.i.eq = +v;
    }
    /**
         * Gets or sets the Title property.
         * The legend item control is created according to the Title on-demand by
         * the series object itself.
        *
        * The `IgxSeriesComponent` `title` may be used in tooltips and legends.
        *
        * ```html
        * <igx-data-chart
        *     [dataSource]="data">
        *     <igx-category-x-axis
        *         label="label"
        *         #xAxis>
        *     </igx-category-x-axis>
        *     <igx-numeric-y-axis
        *         #yAxis>
        *     </igx-numeric-y-axis>
        *     <igx-column-series
        *         [xAxis]="xAxis"
        *         [yAxis]="yAxis"
        *         valueMemberPath="value"
        *         showDefaultTooltip="true"
        *         title="InStock Items">
        *     </igx-column-series>
        * </igx-data-chart>
        * ```
        */
    get title() {
        return this.i.fr;
    }
    set title(v) {
        this.i.fr = v;
    }
    /**
         * Gets or sets the brush to use for the series.
        *
        * The `brush` along with the `outline` and `IgxSeriesComponent` can be used to affect the visuals of the `IgxSeriesComponent`.
        *
        * ```html
        * <igx-data-chart #chart
        *     [dataSource]="data">
        *     <igx-category-x-axis
        *         label="label"
        *         #xAxis>
        *     </igx-category-x-axis>
        *     <igx-numeric-y-axis
        *         #yAxis>
        *     </igx-numeric-y-axis>
        *     <igx-area-series
        *         [xAxis]="xAxis"
        *         [yAxis]="yAxis"
        *         valueMemberPath="value"
        *         brush="red">
        *     </igx-area-series>
        * </igx-data-chart>
        * ```
        */
    get brush() {
        return brushToString(this.i.kw);
    }
    set brush(v) {
        this.i.kw = stringToBrush(v);
    }
    /**
         * Gets the effective brush for the current series object.
        */
    get actualBrush() {
        return brushToString(this.i.ku);
    }
    set actualBrush(v) {
        this.i.ku = stringToBrush(v);
    }
    /**
         * Gets or sets the brush to use for the outline of the series.
         * Some series types, such as LineSeries, do not display outlines.  Therefore, this property does not affect some charts.
        *
        * The `outline` along with the `brush` and `IgxSeriesComponent` can be used to affect the visuals of the `IgxSeriesComponent`.
        *
        * ```html
        * <igx-data-chart #chart
        *     [dataSource]="data">
        *     <igx-category-x-axis
        *         label="label"
        *         #xAxis>
        *     </igx-category-x-axis>
        *     <igx-numeric-y-axis
        *         #yAxis>
        *     </igx-numeric-y-axis>
        *     <igx-area-series
        *         [xAxis]="xAxis"
        *         [yAxis]="yAxis"
        *         valueMemberPath="value"
        *         outline="red">
        *     </igx-area-series>
        * </igx-data-chart>
        * ```
        */
    get outline() {
        return brushToString(this.i.kz);
    }
    set outline(v) {
        this.i.kz = stringToBrush(v);
    }
    /**
         * Gets the effective outline for the current series object.
        */
    get actualOutline() {
        return brushToString(this.i.kv);
    }
    set actualOutline(v) {
        this.i.kv = stringToBrush(v);
    }
    /**
         * Gets or sets the width of the current series object's line thickness.
        *
        * Depending on the `IgxSeriesComponent` type, this can be the main brush used, or just the outline. For example, when using a `IgxSeriesComponent` it will affect the thickness of the lines drawn, whereas when using a `IgxSeriesComponent` it will affect the outer border thickness of the columns.
        *
        * ```html
        * <igx-data-chart
        *     [dataSource]="data">
        *     <igx-category-x-axis
        *         label="label"
        *         #xAxis>
        *     </igx-category-x-axis>
        *     <igx-numeric-y-axis
        *         #yAxis>
        *     </igx-numeric-y-axis>
        *     <igx-line-series
        *         [xAxis]="xAxis"
        *         [yAxis]="yAxis"
        *         valueMemberPath="value"
        *         thickness=5>
        *     </igx-line-series>
        * </igx-data-chart>
        * ```
        */
    get thickness() {
        return this.i.eu;
    }
    set thickness(v) {
        this.i.eu = +v;
    }
    /**
         * Gets or sets whether highlighting should be enabled for this series, if this type of series supports highlighting.
        *
        * ```html
        * <igx-data-chart #chart
        *     [dataSource]="data">
        *     <igx-category-x-axis
        *         label="label"
        *         #xAxis>
        *     </igx-category-x-axis>
        *     <igx-numeric-y-axis
        *         #yAxis>
        *     </igx-numeric-y-axis>
        *     <igx-column-series
        *         [xAxis]="xAxis"
        *         [yAxis]="yAxis"
        *         valueMemberPath="value"
        *         isHighlightEnabled="true">
        *     </igx-column-series>
        * </igx-data-chart>
        * ```
        */
    get isHighlightingEnabled() {
        return this.i.cu;
    }
    set isHighlightingEnabled(v) {
        this.i.cu = ensureBool(v);
    }
    /**
         * Gets or sets whether drop shadow should be enabled for this series.
        *
        * ```html
        * <igx-data-chart
        *     [dataSource]="data">
        *     <igx-category-x-axis
        *         label="label"
        *         #xAxis>
        *     </igx-category-x-axis>
        *     <igx-numeric-y-axis
        *         #yAxis>
        *     </igx-numeric-y-axis>
        *     <igx-line-series
        *         [xAxis]="xAxis"
        *         [yAxis]="yAxis"
        *         valueMemberPath="value"
        *         isDropShadowEnabled=true>
        *     </igx-line-series>
        *     </igx-data-chart>
        * ```
        */
    get isDropShadowEnabled() {
        return this.i.cp;
    }
    set isDropShadowEnabled(v) {
        this.i.cp = ensureBool(v);
    }
    /**
         * Gets or sets the shadow blur.
         * This property is ignored when Series.UseSingleShadow is set to true.
        *
        * `shadowBlur` can be set in conjection with `isDropShadowEnabled` to further define the drop shadow effect.
        *
        * ```html
        * <igx-data-chart
        *     [dataSource]="data">
        *     <igx-category-x-axis
        *         label="label"
        *         #xAxis>
        *     </igx-category-x-axis>
        *     <igx-numeric-y-axis
        *         #yAxis>
        *     </igx-numeric-y-axis>
        *     <igx-column-series
        *         [xAxis]="xAxis"
        *         [yAxis]="yAxis"
        *         valueMemberPath="value"
        *         isDropShadowEnabled="true"
        *         shadowBlur="7"
        *         shadowColor="blue">
        *     </igx-column-series>
        * </igx-data-chart>
        * ```
        */
    get shadowBlur() {
        return this.i.er;
    }
    set shadowBlur(v) {
        this.i.er = +v;
    }
    /**
         * Gets or sets the drop shadow color.
        *
        * `shadowColor` can be set in conjection with `isDropShadowEnabled` to further define the drop shadow effect.
        *
        * ```html
        * <igx-data-chart
        *     [dataSource]="data">
        *     <igx-category-x-axis
        *         label="label"
        *         #xAxis>
        *     </igx-category-x-axis>
        *     <igx-numeric-y-axis
        *         #yAxis>
        *     </igx-numeric-y-axis>
        *     <igx-column-series
        *         [xAxis]="xAxis"
        *         [yAxis]="yAxis"
        *         valueMemberPath="value"
        *         isDropShadowEnabled="true"
        *         shadowBlur="7"
        *         shadowColor="blue">
        *     </igx-column-series>
        * </igx-data-chart>
        * ```
        */
    get shadowColor() {
        return colorToString(this.i.k1);
    }
    set shadowColor(v) {
        this.i.k1 = stringToColor(v);
    }
    /**
         * Gets or sets whether drop shadow is applied to the whole series visual or to each of the individual shapes forming the series.
         * When this property is set to true, no Series.ShadowBlur is applied.
        *
        * ```html
        * <igx-data-chart
        *     [dataSource]="data">
        *     <igx-category-x-axis
        *         label="label"
        *         #xAxis>
        *     </igx-category-x-axis>
        *     <igx-numeric-y-axis
        *         #yAxis>
        *     </igx-numeric-y-axis>
        *     <igx-line-series
        *         [xAxis]="xAxis"
        *         [yAxis]="yAxis"
        *         valueMemberPath="value"
        *         isDropShadowEnabled=true
        *         markerType="circle"
        *         useSingleShadow=true>
        *     </igx-line-series>
        * </igx-data-chart>
        * ```
        */
    get useSingleShadow() {
        return this.i.ds;
    }
    set useSingleShadow(v) {
        this.i.ds = ensureBool(v);
    }
    /**
         * Gets or sets the drop shadow x-offset.
        *
        * `shadowOffsetX` can be set in conjection with `isDropShadowEnabled` to further define the drop shadow effect.
        *
        * ```html
        * <igx-data-chart
        *     [dataSource]="data">
        *     <igx-category-x-axis
        *         label="label"
        *         #xAxis>
        *     </igx-category-x-axis>
        *     <igx-numeric-y-axis
        *         #yAxis>
        *     </igx-numeric-y-axis>
        *     <igx-column-series
        *         [xAxis]="xAxis"
        *         [yAxis]="yAxis"
        *         valueMemberPath="value"
        *         isDropShadowEnabled="true"
        *         shadowOffsetX="10"
        *         shadowOffsetY="10">
        *     </igx-column-series>
        * </igx-data-chart>
        * ```
        */
    get shadowOffsetX() {
        return this.i.es;
    }
    set shadowOffsetX(v) {
        this.i.es = +v;
    }
    /**
         * Gets or sets the drop shadow y-offset.
        *
        * `shadowOffsetY` can be set in conjection with `isDropShadowEnabled` to further define the drop shadow effect.
        *
        * ```html
        * <igx-data-chart
        *     [dataSource]="data">
        *     <igx-category-x-axis
        *         label="label"
        *         #xAxis>
        *     </igx-category-x-axis>
        *     <igx-numeric-y-axis
        *         #yAxis>
        *     </igx-numeric-y-axis>
        *     <igx-column-series
        *         [xAxis]="xAxis"
        *         [yAxis]="yAxis"
        *         valueMemberPath="value"
        *         isDropShadowEnabled="true"
        *         shadowOffsetX="10"
        *         shadowOffsetY="10">
        *     </igx-column-series>
        * </igx-data-chart>
        * ```
        */
    get shadowOffsetY() {
        return this.i.et;
    }
    set shadowOffsetY(v) {
        this.i.et = +v;
    }
    /**
         * Gets or sets the opacity applied to the area fill visual.
         * This property only applies to series that have area visual.
        *
        * ```html
        * <igx-data-chart #chart
        *     [dataSource]="data">
        *     <igx-category-x-axis
        *         label="label"
        *         #xAxis>
        *     </igx-category-x-axis>
        *     <igx-numeric-y-axis
        *         #yAxis>
        *     </igx-numeric-y-axis>
        *     <igx-area-series
        *         [xAxis]="xAxis"
        *         [yAxis]="yAxis"
        *         valueMemberPath="value"
        *         areaFillOpacity=.5>
        *     </igx-area-series>
        * </igx-data-chart>
        * ```
        */
    get areaFillOpacity() {
        return this.i.d3;
    }
    set areaFillOpacity(v) {
        this.i.d3 = +v;
    }
    /**
         * Gets the actual opacity applied to the area fill visual.
        */
    get actualAreaFillOpacity() {
        return this.i.d2;
    }
    set actualAreaFillOpacity(v) {
        this.i.d2 = +v;
    }
    /**
         * Gets if the default tooltip has been selected for display.
        *
        * To use the default tooltip set `showDefaultTooltip` to true.
        */
    get isDefaultToolTipSelected() {
        return this.i.co;
    }
    set isDefaultToolTipSelected(v) {
        this.i.co = ensureBool(v);
    }
    /**
         * Gets or sets whether default tooltip will be shown.
        *
        * The default tooltips display all the information relevant to the particular series item (series title, data values, axis values etc.) and are styled to match the series' style. When using default tooltips, you should also set the series `title`.
        *
        * ```html
        * <igx-data-chart
        *     [dataSource]="data">
        *     <igx-category-x-axis
        *         label="label"
        *         #xAxis>
        *     </igx-category-x-axis>
        *     <igx-numeric-y-axis
        *         #yAxis>
        *     </igx-numeric-y-axis>
        *     <igx-column-series
        *         [xAxis]="xAxis"
        *         [yAxis]="yAxis"
        *         valueMemberPath="value"
        *         showDefaultTooltip="true"
        *         title="InStock Items">
        *     </igx-column-series>
        * </igx-data-chart>
        * ```
        */
    get showDefaultTooltip() {
        return this.i.db;
    }
    set showDefaultTooltip(v) {
        this.i.db = ensureBool(v);
    }
    /**
         * Gets or sets the duration of the current series's transition in morph.
        *
        * The `transitionInDuration` can be used with `IgxSeriesComponent` to cofigure the animation when a new datasource is loaded.
        *
        * ```html
        * <igx-data-chart
        *     [dataSource]="data">
        *     <igx-category-x-axis
        *         label="label"
        *         #xAxis>
        *     </igx-category-x-axis>
        *     <igx-numeric-y-axis
        *         #yAxis>
        *     </igx-numeric-y-axis>
        *     <igx-column-series
        *         [xAxis]="xAxis"
        *         [yAxis]="yAxis"
        *         valueMemberPath="value"
        *         transitionInMode="accordionFromBottom"
        *         isTransitionInEnabled=true
        *         transitionInSpeedType="indexScaled"
        *         transitionDuration=500
        *         transitionInDuration=500>
        *     </igx-column-series>
        * </igx-data-chart>
        * ```
        */
    get transitionInDuration() {
        return this.i.ff;
    }
    set transitionInDuration(v) {
        this.i.ff = +v;
    }
    /**
         * Gets or sets the duration of the current series's transition in morph.
        *
        * The `transitionInSpeedType` can be used with `IgxSeriesComponent` to cofigure the animation when a new datasource is loaded.
        *
        * ```html
        * <igx-data-chart
        *     [dataSource]="data">
        *     <igx-category-x-axis
        *         label="label"
        *         #xAxis>
        *     </igx-category-x-axis>
        *     <igx-numeric-y-axis
        *         #yAxis>
        *     </igx-numeric-y-axis>
        *     <igx-column-series
        *         [xAxis]="xAxis"
        *         [yAxis]="yAxis"
        *         valueMemberPath="value"
        *         transitionInMode="accordionFromBottom"
        *         isTransitionInEnabled=true
        *         transitionInSpeedType="indexScaled"
        *         transitionInDuration=500>
        *     </igx-column-series>
        * </igx-data-chart>
        * ```
        */
    get transitionInSpeedType() {
        return this.i.bp;
    }
    set transitionInSpeedType(v) {
        this.i.bp = ensureEnum(TransitionInSpeedType_$type, v);
    }
    /**
         * Gets or sets the whether the chart reacts to mouse move events.
        */
    get mouseOverEnabled() {
        return this.i.c5;
    }
    set mouseOverEnabled(v) {
        this.i.c5 = ensureBool(v);
    }
    /**
         * Gets or sets the coercion methods to use when loading data from data sources.
         * Should be specified before setting any member paths, if being used. Setting it later
         * will not cause data to be reimported into the chart.
        *
        * ```html
        *  <igx-data-chart
        *       [dataSource]="data"
        *      >
        *       <igx-category-x-axis
        *         label="label"
        *         #xAxis>
        *       </igx-category-x-axis>
        *       <igx-numeric-y-axis
        *         #yAxis>
        *       </igx-numeric-y-axis>
        *       <igx-line-series
        *       [xAxis]="xAxis"
        *       [yAxis]="yAxis"
        *       valueMemberPath="value">
        *      </igx-line-series>
        *        <igx-line-series
        *         [xAxis]="xAxis"
        *         [yAxis]="yAxis"
        *         [coercionMethods]= cMethods
        *         valueMemberPath="value!ValueCoercion">
        *        </igx-line-series>
        *     </igx-data-chart>
        * ```
        *
        * &lt;-- position: content member-->
        */
    get coercionMethods() {
        return this.i.coercionMethods;
    }
    set coercionMethods(v) {
        this.i.coercionMethods = v;
    }
    /**
         * Gets or sets whether the series should expect that properties in its items source may be functions that need to be
         * evaluated to yield their value. This defaults to false, as there will be a subtle performance impact to using this feature.
         * This value must be set before assigning an item's source to take effect.
        *
        * ```html
        * <igx-data-chart
        *     [dataSource]="data">
        *     <igx-category-x-axis
        *     label="label"
        *     #xAxis>
        *     </igx-category-x-axis>
        *     <igx-numeric-y-axis
        *     #yAxis>
        *     </igx-numeric-y-axis>
        *     <igx-line-series
        *     [xAxis]="xAxis"
        *     [yAxis]="yAxis"
        *     expectFunctions=true
        *     valueMemberPath="MyFunction">
        *     </igx-line-series>
        * </igx-data-chart>
        * ```
        */
    get expectFunctions() {
        return this.i.expectFunctions;
    }
    set expectFunctions(v) {
        this.i.expectFunctions = ensureBool(v);
    }
    /**
         * Method of hit testing to use when pointing to items in this series.
        *
        * The `hitTestMode` can be set to either:
        *
        * -   `IgxSeriesComponent`: automatically decide the appropriate hit test mode for the series.
        * -   `IgxSeriesComponent`: use a color encoded off screen buffer for hit testing. Should always be O(1) time for determining a hit series. This increases frame render time and memory usage, however. Consider using this if hit testing time is degrading performance.
        * -   `IgxSeriesComponent`: use a computational based approach to determine whether the series has been hit. This uses loose bounding boxes, in some cases, and can range in time complexity between O(1) and O(log n) to find a hit. This decreases frame render time compared to color encoded
        */
    get hitTestMode() {
        return this.i.be;
    }
    set hitTestMode(v) {
        this.i.be = ensureEnum(SeriesHitTestMode_$type, v);
    }
    /**
         * Resolved method of hit testing to use when pointing to items in the chart.
        */
    get actualHitTestMode() {
        return this.i.bc;
    }
    set actualHitTestMode(v) {
        this.i.bc = ensureEnum(SeriesHitTestMode_$type, v);
    }
    /**
         * Overridden by derived series classes to indicate when negative colors are supported or not.
        */
    get isNegativeColorSupported() {
        return this.i.cz;
    }
    /**
         * Overridden by derived series classes to indicate when markerless display is preferred or not.
        */
    get isMarkerlessDisplayPreferred() {
        return this.i.cy;
    }
    /**
         * The final value of this series.
        */
    get finalValue() {
        return this.i.d4;
    }
    set finalValue(v) {
        this.i.d4 = +v;
    }
    /**
         * The percent change from the beginning to the end of this series.
        */
    get percentChange() {
        return this.i.ep;
    }
    set percentChange(v) {
        this.i.ep = +v;
    }
    /**
         * Gets the brush for tooltip labels.
        
        */
    resolveTooltipBrush() {
        let iv = this.i.go();
        return (iv);
    }
    /**
         * Gets the precise item index, if possible, based on the closeness to the previous or next whole integer. If the series cannot provide this information, GetExactItemIndex will return the same integer value as GetItemIndex.
        
        * @param world  * The world position for which to return the index.
        */
    getExactItemIndex(world) {
        let iv = this.i.d7(toPoint(world));
        return (iv);
    }
    /**
         * Gets the item item index associated with the specified world position
        
        */
    getItemIndex(world) {
        let iv = this.i.e4(toPoint(world));
        return (iv);
    }
    /**
         * Gets the item that is the best match for the specified world coordinates.
        
        * @param world  * The world coordinates to use.
        */
    getItem(world) {
        let iv = this.i.fl(toPoint(world));
        return (iv);
    }
    getPreviousOrExactIndex(world, skipUnknowns) {
        let iv = this.i.fa(toPoint(world), skipUnknowns);
        return (iv);
    }
    getNextOrExactIndex(world, skipUnknowns) {
        let iv = this.i.e8(toPoint(world), skipUnknowns);
        return (iv);
    }
    getSeriesValue(world, useInterpolation, skipUnknowns) {
        let iv = this.i.ej(toPoint(world), useInterpolation, skipUnknowns);
        return (iv);
    }
    getSeriesValuePosition(world, useInterpolation, skipUnknowns) {
        let iv = this.i.lc(toPoint(world), useInterpolation, skipUnknowns);
        return fromPoint(iv);
    }
    /**
         * If possible, will return the best available value bounding box within the series that has the best value match for the world position provided.
        
        * @param world  * The world coordinate for which to get a value bounding box for
        */
    getSeriesValueBoundingBox(world) {
        let iv = this.i.ll(toPoint(world));
        return fromRect(iv);
    }
    /**
         * If possible, will return the best available value marker bounding box within the series that has the best value match for the world position provided.
        
        * @param world  * The world coordinates for which to get a value marker bounding box for
        */
    getSeriesValueMarkerBoundingBox(world) {
        let iv = this.i.ln(toPoint(world));
        return fromRect(iv);
    }
    getSeriesHighValue(world, useInterpolation, skipUnknowns) {
        let iv = this.i.ef(toPoint(world), useInterpolation, skipUnknowns);
        return (iv);
    }
    getSeriesHighValuePosition(world, useInterpolation, skipUnknowns) {
        let iv = this.i.k8(toPoint(world), useInterpolation, skipUnknowns);
        return fromPoint(iv);
    }
    getSeriesLowValue(world, useInterpolation, skipUnknowns) {
        let iv = this.i.eh(toPoint(world), useInterpolation, skipUnknowns);
        return (iv);
    }
    getSeriesLowValuePosition(world, useInterpolation, skipUnknowns) {
        let iv = this.i.la(toPoint(world), useInterpolation, skipUnknowns);
        return fromPoint(iv);
    }
    getSeriesValuePositionFromSeriesPixel(mouse, useInterpolation, skipUnknowns) {
        let iv = this.i.ld(toPoint(mouse), useInterpolation, skipUnknowns);
        return fromPoint(iv);
    }
    getSeriesValueFromSeriesPixel(mouse, useInterpolation, skipUnknowns) {
        let iv = this.i.ek(toPoint(mouse), useInterpolation, skipUnknowns);
        return (iv);
    }
    /**
         * For a category plotted series, returns the current width of the items within the categories. This only returns a value if the items have some form of width (e.g. columns, bars, etc.) otherwise 0 is returned.
        
        */
    getItemSpan() {
        let iv = this.i.ec();
        return (iv);
    }
    /**
         * Converts a point from coordinates within the series plot area to a world position within axis space.
        
        * @param seriesPoint  * The pixel location within the plot area of the series.
        */
    toWorldPosition(seriesPoint) {
        let iv = this.i.lf(toPoint(seriesPoint));
        return fromPoint(iv);
    }
    /**
         * Converts a point from world coordinates to coordinates within the viewport of the series.
        
        * @param world  * The world position from which to convert.
        */
    fromWorldPosition(world) {
        let iv = this.i.k7(toPoint(world));
        return fromPoint(iv);
    }
    /**
         * Requests that the provided item should be brought into view if possible.
        
        * @param item  * The item to attempt to bring into view.
        */
    scrollIntoView(item) {
        let iv = this.i.c7(item);
        return (iv);
    }
    /**
         * Renders the series.
        
        * @param animate  * True if the change should be animated.
        */
    renderSeries(animate) {
        this.i.i4(animate);
    }
    /**
         * Gets the effective viewport, adjusted to account for margins and other factors.
        
        */
    getEffectiveViewport() {
        let iv = this.i.getEffectiveViewport();
        return fromRect(iv);
    }
    /**
         * Removes all alternate views of this series.
        
        */
    removeAllAlternateViews() {
        this.i.iz();
    }
    /**
         * Removes an alternate view of this series.
        
        * @param viewIdentifier  * The string identifier for the view to remove.
        */
    removeAlternateView(viewIdentifier) {
        this.i.i1(viewIdentifier);
    }
    /**
         * Replays the assigned transition in animation, if any.
        
        */
    replayTransitionIn() {
        this.i.i7();
    }
    /**
         * Simulates a pointer hover over the series surface.
        
        * @param point  * The pointer position relative to the series viewport over which to hover.
        *
        * When tooltips are enabled, `simulateHover` can be used to automatically display the tooltip over a particular series item.
        */
    simulateHover(point) {
        this.i.jb(toPoint(point));
    }
    /**
         * Called when this series' Style is updated.
        
        */
    styleUpdated() {
        this.i.jd();
    }
    setNegativeColors(negativeBrush, negativeOutline) {
        this.i.i9(stringToBrush(negativeBrush), stringToBrush(negativeOutline));
    }
    /**
         * Moves the cursor point to the provided world position. Some series may react to the current cursor position.
        
        * @param point  * The cursor point, in world coordinates.
        *
        * `moveCursorPoint` can be used on annotation layers to programitically show the annotation at the given point.
        */
    moveCursorPoint(point) {
        this.i.h4(toPoint(point));
    }
    /**
         * This event is raised every time a render has been requested from a series.
        */
    get renderRequested() {
        if (this._renderRequested == null) {
            this._renderRequested = new EventEmitter();
            this.i.renderRequested = delegateCombine(this.i.renderRequested, (o, e) => {
                let outerArgs = new RenderRequestedEventArgs();
                outerArgs._provideImplementation(e);
                this._renderRequested.emit({
                    sender: this,
                    args: outerArgs
                });
            });
        }
        return this._renderRequested;
    }
    _runInZone(act) {
        if (this._zoneRunner != null) {
            this._zoneRunner(act);
        }
        else {
            act();
        }
    }
}
IgxSeriesComponent.propDecorators = {
    "name": [{ type: Input },],
    "dataSource": [{ type: Input },],
    "tooltipTemplate": [{ type: Input },],
    "tooltipContainerTemplate": [{ type: Input },],
    "legendItemVisibility": [{ type: Input },],
    "legendItemBadgeTemplate": [{ type: Input },],
    "legendItemTemplate": [{ type: Input },],
    "discreteLegendItemTemplate": [{ type: Input },],
    "transitionEasingFunction": [{ type: Input },],
    "transitionInEasingFunction": [{ type: Input },],
    "transitionDuration": [{ type: Input },],
    "resolution": [{ type: Input },],
    "title": [{ type: Input },],
    "brush": [{ type: Input },],
    "actualBrush": [{ type: Input },],
    "outline": [{ type: Input },],
    "actualOutline": [{ type: Input },],
    "thickness": [{ type: Input },],
    "isHighlightingEnabled": [{ type: Input },],
    "isDropShadowEnabled": [{ type: Input },],
    "shadowBlur": [{ type: Input },],
    "shadowColor": [{ type: Input },],
    "useSingleShadow": [{ type: Input },],
    "shadowOffsetX": [{ type: Input },],
    "shadowOffsetY": [{ type: Input },],
    "areaFillOpacity": [{ type: Input },],
    "actualAreaFillOpacity": [{ type: Input },],
    "isDefaultToolTipSelected": [{ type: Input },],
    "showDefaultTooltip": [{ type: Input },],
    "transitionInDuration": [{ type: Input },],
    "transitionInSpeedType": [{ type: Input },],
    "mouseOverEnabled": [{ type: Input },],
    "coercionMethods": [{ type: Input },],
    "expectFunctions": [{ type: Input },],
    "hitTestMode": [{ type: Input },],
    "actualHitTestMode": [{ type: Input },],
    "finalValue": [{ type: Input },],
    "percentChange": [{ type: Input },],
    "renderRequested": [{ type: Output },],
};
//# sourceMappingURL=igx-series-component.js.map