/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
import { EventEmitter, Output, TemplateRef, Input } from '@angular/core';
import { Visibility, Visibility_$type } from "igniteui-angular-core/ES5/Visibility";
import { TransitionInSpeedType, TransitionInSpeedType_$type } from './TransitionInSpeedType';
import { SeriesHitTestMode, SeriesHitTestMode_$type } from './SeriesHitTestMode';
import { brushToString, stringToBrush, toPoint, fromPoint, fromRect, stringToColor, colorToString, ensureEnum, ensureBool } from "igniteui-angular-core/ES5/componentUtil";
import { RenderRequestedEventArgs } from './RenderRequestedEventArgs';
import { delegateCombine, TypeRegistrar } from "igniteui-angular-core/ES5/type";
export var IgxSeriesComponent_PROVIDERS = [];
/**
 * Represents the base class for all IgxDataChartComponent series.
*/
var IgxSeriesComponent = /** @class */ (function () {
    function IgxSeriesComponent() {
        this._chartLevelData = null;
        this._dataSource = null;
        this._tooltipTemplate = null;
        this._tooltipContent = null;
        this._tooltipContainerTemplate = null;
        this._renderer = null;
        this._renderRequested = null;
        this._zoneRunner = null;
        this._implementation = this.createImplementation();
        this._implementation.externalObject = this;
        this.onImplementationCreated();
    }
    Object.defineProperty(IgxSeriesComponent.prototype, "i", {
        get: function () {
            return this._implementation;
        },
        enumerable: true,
        configurable: true
    });
    IgxSeriesComponent.prototype.onImplementationCreated = function () {
    };
    IgxSeriesComponent.prototype.createImplementation = function () {
        return null;
    };
    Object.defineProperty(IgxSeriesComponent.prototype, "seriesInternal", {
        get: function () {
            return this.i;
        },
        enumerable: true,
        configurable: true
    });
    IgxSeriesComponent.prototype.ngOnInit = function () {
    };
    Object.defineProperty(IgxSeriesComponent.prototype, "name", {
        get: function () {
            return this.i.name;
        },
        set: function (value) {
            this.i.name = value;
        },
        enumerable: true,
        configurable: true
    });
    IgxSeriesComponent.prototype.provideData = function (data) {
        this._chartLevelData = data;
        this.updateDataSource();
    };
    IgxSeriesComponent.prototype.updateDataSource = function () {
        if (this._dataSource == null) {
            this.i.itemsSource = this._chartLevelData;
        }
        else {
            this.i.itemsSource = this._dataSource;
        }
    };
    Object.defineProperty(IgxSeriesComponent.prototype, "dataSource", {
        get: function () {
            if (this._dataSource != null) {
                return this._dataSource;
            }
            return this.i.itemsSource;
        },
        set: function (value) {
            this._dataSource = value;
            this.updateDataSource();
            //console.log("setting axis data source: " + value)
        },
        enumerable: true,
        configurable: true
    });
    IgxSeriesComponent.prototype.bindAxes = function (axes) {
    };
    Object.defineProperty(IgxSeriesComponent.prototype, "tooltipTemplate", {
        get: function () {
            return this._tooltipTemplate;
        },
        set: function (value) {
            this._tooltipTemplate = value;
            if (value == null) {
                if (this._tooltipContent !== null) {
                    this._tooltipContent.destroy();
                    this._tooltipContent = null;
                }
            }
            if (this._tooltipContent != null) {
                this._tooltipContent.instance.template = this._tooltipTemplate;
            }
            else {
                if (this.owner != null) {
                    this.owner._ensureTooltipCreated(this);
                }
            }
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgxSeriesComponent.prototype, "tooltipContainerTemplate", {
        get: function () {
            return this._tooltipContainerTemplate;
        },
        set: function (value) {
            this._tooltipContainerTemplate = value;
            if (this._tooltipContent != null) {
                this._tooltipContent.instance.containerTemplate = this._tooltipContainerTemplate;
            }
        },
        enumerable: true,
        configurable: true
    });
    IgxSeriesComponent.prototype._ensureTooltipCreated = function (createTooltip, createWrapper) {
        if (this._tooltipTemplate == null) {
            this.i.toolTip = null;
        }
        if (this._tooltipContent == null && this._tooltipTemplate != null) {
            var tooltip = createTooltip();
            if (tooltip == null) {
                return;
            }
            this._tooltipContent = tooltip;
            tooltip.instance.template = this._tooltipTemplate;
            this.i.toolTip = createWrapper(tooltip.location.nativeElement);
        }
    };
    IgxSeriesComponent.prototype._ensureTooltipDestroyed = function () {
        if (this._tooltipContent !== null) {
            this._tooltipContent.destroy();
            this._tooltipContent = null;
        }
    };
    IgxSeriesComponent.prototype._provideRenderer = function (renderer) {
        this._renderer = renderer;
        this._zoneRunner = function (act) { return renderer._ngZone.run(act); };
    };
    IgxSeriesComponent._createFromInternal = function (internal) {
        if (!internal) {
            return null;
        }
        if (!internal.$type) {
            return null;
        }
        var name = internal.$type.name;
        var externalName = "Igx" + name + "Component";
        if (!TypeRegistrar.isRegistered(externalName)) {
            return null;
        }
        return TypeRegistrar.create(externalName);
    };
    Object.defineProperty(IgxSeriesComponent.prototype, "isAnnotationLayer", {
        /**
     * Gets whether the series is an annotation layer.
    */
        get: /**
             * Gets whether the series is an annotation layer.
            */
        function () {
            return this.i.cj;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgxSeriesComponent.prototype, "isVertical", {
        /**
         * Gets whether the current series is oriented vertically.
        */
        get: /**
             * Gets whether the current series is oriented vertically.
            */
        function () {
            return this.i.isVertical;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgxSeriesComponent.prototype, "isFragment", {
        /**
         * Gets whether the current series is a stack fragment.
        */
        get: /**
             * Gets whether the current series is a stack fragment.
            */
        function () {
            return this.i.cs;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgxSeriesComponent.prototype, "isAreaOrLine", {
        /**
         * Gets whether the current series shows an area or line shape.
        */
        get: /**
             * Gets whether the current series shows an area or line shape.
            */
        function () {
            return this.i.ck;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgxSeriesComponent.prototype, "isPolar", {
        /**
         * Gets whether the current series is a polar type series.
        */
        get: /**
             * Gets whether the current series is a polar type series.
            */
        function () {
            return this.i.c0;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgxSeriesComponent.prototype, "isScatter", {
        /**
         * Gets whether the current series is a scatter type series.
        */
        get: /**
             * Gets whether the current series is a scatter type series.
            */
        function () {
            return this.i.c4;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgxSeriesComponent.prototype, "isRadial", {
        /**
         * Gets whether the current series is a radial type series.
        */
        get: /**
             * Gets whether the current series is a radial type series.
            */
        function () {
            return this.i.c2;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgxSeriesComponent.prototype, "isStacked", {
        /**
         * Gets whether the current series is a stacked type series.
        */
        get: /**
             * Gets whether the current series is a stacked type series.
            */
        function () {
            return this.i.isStacked;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgxSeriesComponent.prototype, "isFinancial", {
        /**
         * Gets whether the current series is a financial type series.
        */
        get: /**
             * Gets whether the current series is a financial type series.
            */
        function () {
            return this.i.cr;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgxSeriesComponent.prototype, "isRange", {
        /**
         * Gets whether the current series is a range type series.
        */
        get: /**
             * Gets whether the current series is a range type series.
            */
        function () {
            return this.i.c3;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgxSeriesComponent.prototype, "isCategory", {
        /**
         * Gets whether the current series is a category type series.
        */
        get: /**
             * Gets whether the current series is a category type series.
            */
        function () {
            return this.i.cl;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgxSeriesComponent.prototype, "isGeographic", {
        /**
         * Gets whether the current seires is a geogrpahic series.
        */
        get: /**
             * Gets whether the current seires is a geogrpahic series.
            */
        function () {
            return this.i.ct;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgxSeriesComponent.prototype, "isDefaultCrosshairBehaviorDisabled", {
        /**
         * Gets whether the default crosshair behavior should be disabled if this series is present.
        *
        * `isDefaultCrosshairBehaviorDisabled` defaults to true for annotation layers. When not using annotaion layers, you can show crosshairs by setting the chart's `IgxSeriesComponent` to true.
        */
        get: /**
             * Gets whether the default crosshair behavior should be disabled if this series is present.
            *
            * `isDefaultCrosshairBehaviorDisabled` defaults to true for annotation layers. When not using annotaion layers, you can show crosshairs by setting the chart's `IgxSeriesComponent` to true.
            */
        function () {
            return this.i.cm;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgxSeriesComponent.prototype, "isDefaultTooltipBehaviorDisabled", {
        /**
         * Gets whether the default tooltip behavior should be disabled if this series is present.
        */
        get: /**
             * Gets whether the default tooltip behavior should be disabled if this series is present.
            */
        function () {
            return this.i.cn;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgxSeriesComponent.prototype, "hasMarkers", {
        /**
         * Returns whether the current series supports visual markers.
        */
        get: /**
             * Returns whether the current series supports visual markers.
            */
        function () {
            return this.i.hasMarkers;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgxSeriesComponent.prototype, "isIndexed", {
        /**
         * Gets if the series uses an index, which can be used to auto-assign it a color.
        */
        get: /**
             * Gets if the series uses an index, which can be used to auto-assign it a color.
            */
        function () {
            return this.i.cw;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgxSeriesComponent.prototype, "isUsableInLegend", {
        /**
         * Gets if the series should appear in any legends.
        */
        get: /**
             * Gets if the series should appear in any legends.
            */
        function () {
            return this.i.isUsableInLegend;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgxSeriesComponent.prototype, "legendItemVisibility", {
        /**
         * Gets or sets the legend item visibility for the current series object.
        *
        * The `IgxSeriesComponent` can be used to exclude only certain `IgxSeriesComponent` from the `IgxSeriesComponent`.
        */
        get: /**
             * Gets or sets the legend item visibility for the current series object.
            *
            * The `IgxSeriesComponent` can be used to exclude only certain `IgxSeriesComponent` from the `IgxSeriesComponent`.
            */
        function () {
            return this.i.lq;
        },
        set: function (v) {
            this.i.lq = ensureEnum(Visibility_$type, v);
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgxSeriesComponent.prototype, "legendItemBadgeTemplate", {
        /**
         * Gets or sets the LegendItemBadgeTemplate property.
         * The legend item badge is created according to the LegendItemBadgeTemplate on-demand by
         * the series object itself.
        *
        * The `legendItemBadgeTemplate` is used to describe the visual structure of the badge icon for each legend item.
        */
        get: /**
             * Gets or sets the LegendItemBadgeTemplate property.
             * The legend item badge is created according to the LegendItemBadgeTemplate on-demand by
             * the series object itself.
            *
            * The `legendItemBadgeTemplate` is used to describe the visual structure of the badge icon for each legend item.
            */
        function () {
            return this.i.legendItemBadgeTemplate;
        },
        set: function (v) {
            this.i.legendItemBadgeTemplate = v;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgxSeriesComponent.prototype, "legendItemTemplate", {
        /**
         * Gets or sets the LegendItemTemplate property.
         * The legend item control content is created according to the LegendItemTemplate on-demand by
         * the series object itself.
        *
        * The `legendItemTemplate` is used to describe the visual structure of each legend item in the `IgxSeriesComponent`.
        */
        get: /**
             * Gets or sets the LegendItemTemplate property.
             * The legend item control content is created according to the LegendItemTemplate on-demand by
             * the series object itself.
            *
            * The `legendItemTemplate` is used to describe the visual structure of each legend item in the `IgxSeriesComponent`.
            */
        function () {
            return this.i.legendItemTemplate;
        },
        set: function (v) {
            this.i.legendItemTemplate = v;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgxSeriesComponent.prototype, "discreteLegendItemTemplate", {
        /**
         * Gets or sets the DiscreteLegendItemTemplate property.
         * The legend item control content is created according to the DiscreteLegendItemTemplate on-demand by
         * the series object itself.
        *
        * The legend item control content is created according to the DiscreteLegendItemTemplate on-demand by the series object itself
        */
        get: /**
             * Gets or sets the DiscreteLegendItemTemplate property.
             * The legend item control content is created according to the DiscreteLegendItemTemplate on-demand by
             * the series object itself.
            *
            * The legend item control content is created according to the DiscreteLegendItemTemplate on-demand by the series object itself
            */
        function () {
            return this.i.jp;
        },
        set: function (v) {
            this.i.jp = v;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgxSeriesComponent.prototype, "transitionEasingFunction", {
        /**
         * Gets or sets the easing function used to morph the current series.
        *
        * The `IgxSeriesComponent` and `transitionEasingFunction` can be used to play animation when data is added or removed from a `IgxSeriesComponent`. To play an initial animation see `transitionInDuration`.
        */
        get: /**
             * Gets or sets the easing function used to morph the current series.
            *
            * The `IgxSeriesComponent` and `transitionEasingFunction` can be used to play animation when data is added or removed from a `IgxSeriesComponent`. To play an initial animation see `transitionInDuration`.
            */
        function () {
            return this.i.bu;
        },
        set: function (v) {
            this.i.bu = v;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgxSeriesComponent.prototype, "transitionInEasingFunction", {
        /**
         * Gets or sets the EasingFunction used to morph the current series during the initial transition.
        *
        * The `transitionInEasingFunction` can be used with `IgxSeriesComponent` to cofigure the animation when a new datasource is loaded.
        */
        get: /**
             * Gets or sets the EasingFunction used to morph the current series during the initial transition.
            *
            * The `transitionInEasingFunction` can be used with `IgxSeriesComponent` to cofigure the animation when a new datasource is loaded.
            */
        function () {
            return this.i.bv;
        },
        set: function (v) {
            this.i.bv = v;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgxSeriesComponent.prototype, "transitionDuration", {
        /**
         * Gets or sets the duration of the current series's morph.
        *
        * The `transitionDuration` can be used to play animation when data is added or removed from a `IgxSeriesComponent`. To play an initial animation see `transitionInDuration`.
        *
        * ```html
        * <igx-data-chart
        *     [dataSource]="data"
        *     animateSeriesWhenAxisRangeChanges=true>
        *     <igx-category-x-axis
        *         label="label"
        *         #xAxis>
        *     </igx-category-x-axis>
        *     <igx-numeric-y-axis
        *         #yAxis>
        *     </igx-numeric-y-axis>
        *     <igx-column-series
        *         [xAxis]="xAxis"
        *         [yAxis]="yAxis"
        *         valueMemberPath="value"
        *         transitionInMode="accordionFromBottom"
        *         isTransitionInEnabled=true
        *         transitionInSpeedType="indexScaled"
        *         transitionDuration=500
        *         transitionInDuration=500>
        *     </igx-column-series>
        * </igx-data-chart>
        * ```
        */
        get: /**
             * Gets or sets the duration of the current series's morph.
            *
            * The `transitionDuration` can be used to play animation when data is added or removed from a `IgxSeriesComponent`. To play an initial animation see `transitionInDuration`.
            *
            * ```html
            * <igx-data-chart
            *     [dataSource]="data"
            *     animateSeriesWhenAxisRangeChanges=true>
            *     <igx-category-x-axis
            *         label="label"
            *         #xAxis>
            *     </igx-category-x-axis>
            *     <igx-numeric-y-axis
            *         #yAxis>
            *     </igx-numeric-y-axis>
            *     <igx-column-series
            *         [xAxis]="xAxis"
            *         [yAxis]="yAxis"
            *         valueMemberPath="value"
            *         transitionInMode="accordionFromBottom"
            *         isTransitionInEnabled=true
            *         transitionInSpeedType="indexScaled"
            *         transitionDuration=500
            *         transitionInDuration=500>
            *     </igx-column-series>
            * </igx-data-chart>
            * ```
            */
        function () {
            return this.i.fe;
        },
        set: function (v) {
            this.i.fe = +v;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgxSeriesComponent.prototype, "resolution", {
        /**
         * Gets or sets the current series object's rendering resolution.
        *
        * Setting the `resolution` on a Series to a higher value can help with performance, but it will lower the graphical fidelity of the line. As such, it can be increased up until the fidelity is unacceptable.
        *
        * ```html
        *  <igx-data-chart
        *     [dataSource]="data">
        *     <igx-category-x-axis
        *         label="label"
        *         #xAxis>
        *     </igx-category-x-axis>
        *     <igx-numeric-y-axis
        *         #yAxis>
        *     </igx-numeric-y-axis>
        *     <igx-line-series
        *         [xAxis]="xAxis"
        *         [yAxis]="yAxis"
        *         valueMemberPath="value"
        *         resolution=1.5>
        *     </igx-line-series>
        * </igx-data-chart>
        * ```
        *
        *
        */
        get: /**
             * Gets or sets the current series object's rendering resolution.
            *
            * Setting the `resolution` on a Series to a higher value can help with performance, but it will lower the graphical fidelity of the line. As such, it can be increased up until the fidelity is unacceptable.
            *
            * ```html
            *  <igx-data-chart
            *     [dataSource]="data">
            *     <igx-category-x-axis
            *         label="label"
            *         #xAxis>
            *     </igx-category-x-axis>
            *     <igx-numeric-y-axis
            *         #yAxis>
            *     </igx-numeric-y-axis>
            *     <igx-line-series
            *         [xAxis]="xAxis"
            *         [yAxis]="yAxis"
            *         valueMemberPath="value"
            *         resolution=1.5>
            *     </igx-line-series>
            * </igx-data-chart>
            * ```
            *
            *
            */
        function () {
            return this.i.eq;
        },
        set: function (v) {
            this.i.eq = +v;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgxSeriesComponent.prototype, "title", {
        /**
         * Gets or sets the Title property.
         * The legend item control is created according to the Title on-demand by
         * the series object itself.
        *
        * The `IgxSeriesComponent` `title` may be used in tooltips and legends.
        *
        * ```html
        * <igx-data-chart
        *     [dataSource]="data">
        *     <igx-category-x-axis
        *         label="label"
        *         #xAxis>
        *     </igx-category-x-axis>
        *     <igx-numeric-y-axis
        *         #yAxis>
        *     </igx-numeric-y-axis>
        *     <igx-column-series
        *         [xAxis]="xAxis"
        *         [yAxis]="yAxis"
        *         valueMemberPath="value"
        *         showDefaultTooltip="true"
        *         title="InStock Items">
        *     </igx-column-series>
        * </igx-data-chart>
        * ```
        */
        get: /**
             * Gets or sets the Title property.
             * The legend item control is created according to the Title on-demand by
             * the series object itself.
            *
            * The `IgxSeriesComponent` `title` may be used in tooltips and legends.
            *
            * ```html
            * <igx-data-chart
            *     [dataSource]="data">
            *     <igx-category-x-axis
            *         label="label"
            *         #xAxis>
            *     </igx-category-x-axis>
            *     <igx-numeric-y-axis
            *         #yAxis>
            *     </igx-numeric-y-axis>
            *     <igx-column-series
            *         [xAxis]="xAxis"
            *         [yAxis]="yAxis"
            *         valueMemberPath="value"
            *         showDefaultTooltip="true"
            *         title="InStock Items">
            *     </igx-column-series>
            * </igx-data-chart>
            * ```
            */
        function () {
            return this.i.fr;
        },
        set: function (v) {
            this.i.fr = v;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgxSeriesComponent.prototype, "brush", {
        /**
         * Gets or sets the brush to use for the series.
        *
        * The `brush` along with the `outline` and `IgxSeriesComponent` can be used to affect the visuals of the `IgxSeriesComponent`.
        *
        * ```html
        * <igx-data-chart #chart
        *     [dataSource]="data">
        *     <igx-category-x-axis
        *         label="label"
        *         #xAxis>
        *     </igx-category-x-axis>
        *     <igx-numeric-y-axis
        *         #yAxis>
        *     </igx-numeric-y-axis>
        *     <igx-area-series
        *         [xAxis]="xAxis"
        *         [yAxis]="yAxis"
        *         valueMemberPath="value"
        *         brush="red">
        *     </igx-area-series>
        * </igx-data-chart>
        * ```
        */
        get: /**
             * Gets or sets the brush to use for the series.
            *
            * The `brush` along with the `outline` and `IgxSeriesComponent` can be used to affect the visuals of the `IgxSeriesComponent`.
            *
            * ```html
            * <igx-data-chart #chart
            *     [dataSource]="data">
            *     <igx-category-x-axis
            *         label="label"
            *         #xAxis>
            *     </igx-category-x-axis>
            *     <igx-numeric-y-axis
            *         #yAxis>
            *     </igx-numeric-y-axis>
            *     <igx-area-series
            *         [xAxis]="xAxis"
            *         [yAxis]="yAxis"
            *         valueMemberPath="value"
            *         brush="red">
            *     </igx-area-series>
            * </igx-data-chart>
            * ```
            */
        function () {
            return brushToString(this.i.kw);
        },
        set: function (v) {
            this.i.kw = stringToBrush(v);
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgxSeriesComponent.prototype, "actualBrush", {
        /**
         * Gets the effective brush for the current series object.
        */
        get: /**
             * Gets the effective brush for the current series object.
            */
        function () {
            return brushToString(this.i.ku);
        },
        set: function (v) {
            this.i.ku = stringToBrush(v);
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgxSeriesComponent.prototype, "outline", {
        /**
         * Gets or sets the brush to use for the outline of the series.
         * Some series types, such as LineSeries, do not display outlines.  Therefore, this property does not affect some charts.
        *
        * The `outline` along with the `brush` and `IgxSeriesComponent` can be used to affect the visuals of the `IgxSeriesComponent`.
        *
        * ```html
        * <igx-data-chart #chart
        *     [dataSource]="data">
        *     <igx-category-x-axis
        *         label="label"
        *         #xAxis>
        *     </igx-category-x-axis>
        *     <igx-numeric-y-axis
        *         #yAxis>
        *     </igx-numeric-y-axis>
        *     <igx-area-series
        *         [xAxis]="xAxis"
        *         [yAxis]="yAxis"
        *         valueMemberPath="value"
        *         outline="red">
        *     </igx-area-series>
        * </igx-data-chart>
        * ```
        */
        get: /**
             * Gets or sets the brush to use for the outline of the series.
             * Some series types, such as LineSeries, do not display outlines.  Therefore, this property does not affect some charts.
            *
            * The `outline` along with the `brush` and `IgxSeriesComponent` can be used to affect the visuals of the `IgxSeriesComponent`.
            *
            * ```html
            * <igx-data-chart #chart
            *     [dataSource]="data">
            *     <igx-category-x-axis
            *         label="label"
            *         #xAxis>
            *     </igx-category-x-axis>
            *     <igx-numeric-y-axis
            *         #yAxis>
            *     </igx-numeric-y-axis>
            *     <igx-area-series
            *         [xAxis]="xAxis"
            *         [yAxis]="yAxis"
            *         valueMemberPath="value"
            *         outline="red">
            *     </igx-area-series>
            * </igx-data-chart>
            * ```
            */
        function () {
            return brushToString(this.i.kz);
        },
        set: function (v) {
            this.i.kz = stringToBrush(v);
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgxSeriesComponent.prototype, "actualOutline", {
        /**
         * Gets the effective outline for the current series object.
        */
        get: /**
             * Gets the effective outline for the current series object.
            */
        function () {
            return brushToString(this.i.kv);
        },
        set: function (v) {
            this.i.kv = stringToBrush(v);
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgxSeriesComponent.prototype, "thickness", {
        /**
         * Gets or sets the width of the current series object's line thickness.
        *
        * Depending on the `IgxSeriesComponent` type, this can be the main brush used, or just the outline. For example, when using a `IgxSeriesComponent` it will affect the thickness of the lines drawn, whereas when using a `IgxSeriesComponent` it will affect the outer border thickness of the columns.
        *
        * ```html
        * <igx-data-chart
        *     [dataSource]="data">
        *     <igx-category-x-axis
        *         label="label"
        *         #xAxis>
        *     </igx-category-x-axis>
        *     <igx-numeric-y-axis
        *         #yAxis>
        *     </igx-numeric-y-axis>
        *     <igx-line-series
        *         [xAxis]="xAxis"
        *         [yAxis]="yAxis"
        *         valueMemberPath="value"
        *         thickness=5>
        *     </igx-line-series>
        * </igx-data-chart>
        * ```
        */
        get: /**
             * Gets or sets the width of the current series object's line thickness.
            *
            * Depending on the `IgxSeriesComponent` type, this can be the main brush used, or just the outline. For example, when using a `IgxSeriesComponent` it will affect the thickness of the lines drawn, whereas when using a `IgxSeriesComponent` it will affect the outer border thickness of the columns.
            *
            * ```html
            * <igx-data-chart
            *     [dataSource]="data">
            *     <igx-category-x-axis
            *         label="label"
            *         #xAxis>
            *     </igx-category-x-axis>
            *     <igx-numeric-y-axis
            *         #yAxis>
            *     </igx-numeric-y-axis>
            *     <igx-line-series
            *         [xAxis]="xAxis"
            *         [yAxis]="yAxis"
            *         valueMemberPath="value"
            *         thickness=5>
            *     </igx-line-series>
            * </igx-data-chart>
            * ```
            */
        function () {
            return this.i.eu;
        },
        set: function (v) {
            this.i.eu = +v;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgxSeriesComponent.prototype, "isHighlightingEnabled", {
        /**
         * Gets or sets whether highlighting should be enabled for this series, if this type of series supports highlighting.
        *
        * ```html
        * <igx-data-chart #chart
        *     [dataSource]="data">
        *     <igx-category-x-axis
        *         label="label"
        *         #xAxis>
        *     </igx-category-x-axis>
        *     <igx-numeric-y-axis
        *         #yAxis>
        *     </igx-numeric-y-axis>
        *     <igx-column-series
        *         [xAxis]="xAxis"
        *         [yAxis]="yAxis"
        *         valueMemberPath="value"
        *         isHighlightEnabled="true">
        *     </igx-column-series>
        * </igx-data-chart>
        * ```
        */
        get: /**
             * Gets or sets whether highlighting should be enabled for this series, if this type of series supports highlighting.
            *
            * ```html
            * <igx-data-chart #chart
            *     [dataSource]="data">
            *     <igx-category-x-axis
            *         label="label"
            *         #xAxis>
            *     </igx-category-x-axis>
            *     <igx-numeric-y-axis
            *         #yAxis>
            *     </igx-numeric-y-axis>
            *     <igx-column-series
            *         [xAxis]="xAxis"
            *         [yAxis]="yAxis"
            *         valueMemberPath="value"
            *         isHighlightEnabled="true">
            *     </igx-column-series>
            * </igx-data-chart>
            * ```
            */
        function () {
            return this.i.cu;
        },
        set: function (v) {
            this.i.cu = ensureBool(v);
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgxSeriesComponent.prototype, "isDropShadowEnabled", {
        /**
         * Gets or sets whether drop shadow should be enabled for this series.
        *
        * ```html
        * <igx-data-chart
        *     [dataSource]="data">
        *     <igx-category-x-axis
        *         label="label"
        *         #xAxis>
        *     </igx-category-x-axis>
        *     <igx-numeric-y-axis
        *         #yAxis>
        *     </igx-numeric-y-axis>
        *     <igx-line-series
        *         [xAxis]="xAxis"
        *         [yAxis]="yAxis"
        *         valueMemberPath="value"
        *         isDropShadowEnabled=true>
        *     </igx-line-series>
        *     </igx-data-chart>
        * ```
        */
        get: /**
             * Gets or sets whether drop shadow should be enabled for this series.
            *
            * ```html
            * <igx-data-chart
            *     [dataSource]="data">
            *     <igx-category-x-axis
            *         label="label"
            *         #xAxis>
            *     </igx-category-x-axis>
            *     <igx-numeric-y-axis
            *         #yAxis>
            *     </igx-numeric-y-axis>
            *     <igx-line-series
            *         [xAxis]="xAxis"
            *         [yAxis]="yAxis"
            *         valueMemberPath="value"
            *         isDropShadowEnabled=true>
            *     </igx-line-series>
            *     </igx-data-chart>
            * ```
            */
        function () {
            return this.i.cp;
        },
        set: function (v) {
            this.i.cp = ensureBool(v);
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgxSeriesComponent.prototype, "shadowBlur", {
        /**
         * Gets or sets the shadow blur.
         * This property is ignored when Series.UseSingleShadow is set to true.
        *
        * `shadowBlur` can be set in conjection with `isDropShadowEnabled` to further define the drop shadow effect.
        *
        * ```html
        * <igx-data-chart
        *     [dataSource]="data">
        *     <igx-category-x-axis
        *         label="label"
        *         #xAxis>
        *     </igx-category-x-axis>
        *     <igx-numeric-y-axis
        *         #yAxis>
        *     </igx-numeric-y-axis>
        *     <igx-column-series
        *         [xAxis]="xAxis"
        *         [yAxis]="yAxis"
        *         valueMemberPath="value"
        *         isDropShadowEnabled="true"
        *         shadowBlur="7"
        *         shadowColor="blue">
        *     </igx-column-series>
        * </igx-data-chart>
        * ```
        */
        get: /**
             * Gets or sets the shadow blur.
             * This property is ignored when Series.UseSingleShadow is set to true.
            *
            * `shadowBlur` can be set in conjection with `isDropShadowEnabled` to further define the drop shadow effect.
            *
            * ```html
            * <igx-data-chart
            *     [dataSource]="data">
            *     <igx-category-x-axis
            *         label="label"
            *         #xAxis>
            *     </igx-category-x-axis>
            *     <igx-numeric-y-axis
            *         #yAxis>
            *     </igx-numeric-y-axis>
            *     <igx-column-series
            *         [xAxis]="xAxis"
            *         [yAxis]="yAxis"
            *         valueMemberPath="value"
            *         isDropShadowEnabled="true"
            *         shadowBlur="7"
            *         shadowColor="blue">
            *     </igx-column-series>
            * </igx-data-chart>
            * ```
            */
        function () {
            return this.i.er;
        },
        set: function (v) {
            this.i.er = +v;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgxSeriesComponent.prototype, "shadowColor", {
        /**
         * Gets or sets the drop shadow color.
        *
        * `shadowColor` can be set in conjection with `isDropShadowEnabled` to further define the drop shadow effect.
        *
        * ```html
        * <igx-data-chart
        *     [dataSource]="data">
        *     <igx-category-x-axis
        *         label="label"
        *         #xAxis>
        *     </igx-category-x-axis>
        *     <igx-numeric-y-axis
        *         #yAxis>
        *     </igx-numeric-y-axis>
        *     <igx-column-series
        *         [xAxis]="xAxis"
        *         [yAxis]="yAxis"
        *         valueMemberPath="value"
        *         isDropShadowEnabled="true"
        *         shadowBlur="7"
        *         shadowColor="blue">
        *     </igx-column-series>
        * </igx-data-chart>
        * ```
        */
        get: /**
             * Gets or sets the drop shadow color.
            *
            * `shadowColor` can be set in conjection with `isDropShadowEnabled` to further define the drop shadow effect.
            *
            * ```html
            * <igx-data-chart
            *     [dataSource]="data">
            *     <igx-category-x-axis
            *         label="label"
            *         #xAxis>
            *     </igx-category-x-axis>
            *     <igx-numeric-y-axis
            *         #yAxis>
            *     </igx-numeric-y-axis>
            *     <igx-column-series
            *         [xAxis]="xAxis"
            *         [yAxis]="yAxis"
            *         valueMemberPath="value"
            *         isDropShadowEnabled="true"
            *         shadowBlur="7"
            *         shadowColor="blue">
            *     </igx-column-series>
            * </igx-data-chart>
            * ```
            */
        function () {
            return colorToString(this.i.k1);
        },
        set: function (v) {
            this.i.k1 = stringToColor(v);
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgxSeriesComponent.prototype, "useSingleShadow", {
        /**
         * Gets or sets whether drop shadow is applied to the whole series visual or to each of the individual shapes forming the series.
         * When this property is set to true, no Series.ShadowBlur is applied.
        *
        * ```html
        * <igx-data-chart
        *     [dataSource]="data">
        *     <igx-category-x-axis
        *         label="label"
        *         #xAxis>
        *     </igx-category-x-axis>
        *     <igx-numeric-y-axis
        *         #yAxis>
        *     </igx-numeric-y-axis>
        *     <igx-line-series
        *         [xAxis]="xAxis"
        *         [yAxis]="yAxis"
        *         valueMemberPath="value"
        *         isDropShadowEnabled=true
        *         markerType="circle"
        *         useSingleShadow=true>
        *     </igx-line-series>
        * </igx-data-chart>
        * ```
        */
        get: /**
             * Gets or sets whether drop shadow is applied to the whole series visual or to each of the individual shapes forming the series.
             * When this property is set to true, no Series.ShadowBlur is applied.
            *
            * ```html
            * <igx-data-chart
            *     [dataSource]="data">
            *     <igx-category-x-axis
            *         label="label"
            *         #xAxis>
            *     </igx-category-x-axis>
            *     <igx-numeric-y-axis
            *         #yAxis>
            *     </igx-numeric-y-axis>
            *     <igx-line-series
            *         [xAxis]="xAxis"
            *         [yAxis]="yAxis"
            *         valueMemberPath="value"
            *         isDropShadowEnabled=true
            *         markerType="circle"
            *         useSingleShadow=true>
            *     </igx-line-series>
            * </igx-data-chart>
            * ```
            */
        function () {
            return this.i.ds;
        },
        set: function (v) {
            this.i.ds = ensureBool(v);
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgxSeriesComponent.prototype, "shadowOffsetX", {
        /**
         * Gets or sets the drop shadow x-offset.
        *
        * `shadowOffsetX` can be set in conjection with `isDropShadowEnabled` to further define the drop shadow effect.
        *
        * ```html
        * <igx-data-chart
        *     [dataSource]="data">
        *     <igx-category-x-axis
        *         label="label"
        *         #xAxis>
        *     </igx-category-x-axis>
        *     <igx-numeric-y-axis
        *         #yAxis>
        *     </igx-numeric-y-axis>
        *     <igx-column-series
        *         [xAxis]="xAxis"
        *         [yAxis]="yAxis"
        *         valueMemberPath="value"
        *         isDropShadowEnabled="true"
        *         shadowOffsetX="10"
        *         shadowOffsetY="10">
        *     </igx-column-series>
        * </igx-data-chart>
        * ```
        */
        get: /**
             * Gets or sets the drop shadow x-offset.
            *
            * `shadowOffsetX` can be set in conjection with `isDropShadowEnabled` to further define the drop shadow effect.
            *
            * ```html
            * <igx-data-chart
            *     [dataSource]="data">
            *     <igx-category-x-axis
            *         label="label"
            *         #xAxis>
            *     </igx-category-x-axis>
            *     <igx-numeric-y-axis
            *         #yAxis>
            *     </igx-numeric-y-axis>
            *     <igx-column-series
            *         [xAxis]="xAxis"
            *         [yAxis]="yAxis"
            *         valueMemberPath="value"
            *         isDropShadowEnabled="true"
            *         shadowOffsetX="10"
            *         shadowOffsetY="10">
            *     </igx-column-series>
            * </igx-data-chart>
            * ```
            */
        function () {
            return this.i.es;
        },
        set: function (v) {
            this.i.es = +v;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgxSeriesComponent.prototype, "shadowOffsetY", {
        /**
         * Gets or sets the drop shadow y-offset.
        *
        * `shadowOffsetY` can be set in conjection with `isDropShadowEnabled` to further define the drop shadow effect.
        *
        * ```html
        * <igx-data-chart
        *     [dataSource]="data">
        *     <igx-category-x-axis
        *         label="label"
        *         #xAxis>
        *     </igx-category-x-axis>
        *     <igx-numeric-y-axis
        *         #yAxis>
        *     </igx-numeric-y-axis>
        *     <igx-column-series
        *         [xAxis]="xAxis"
        *         [yAxis]="yAxis"
        *         valueMemberPath="value"
        *         isDropShadowEnabled="true"
        *         shadowOffsetX="10"
        *         shadowOffsetY="10">
        *     </igx-column-series>
        * </igx-data-chart>
        * ```
        */
        get: /**
             * Gets or sets the drop shadow y-offset.
            *
            * `shadowOffsetY` can be set in conjection with `isDropShadowEnabled` to further define the drop shadow effect.
            *
            * ```html
            * <igx-data-chart
            *     [dataSource]="data">
            *     <igx-category-x-axis
            *         label="label"
            *         #xAxis>
            *     </igx-category-x-axis>
            *     <igx-numeric-y-axis
            *         #yAxis>
            *     </igx-numeric-y-axis>
            *     <igx-column-series
            *         [xAxis]="xAxis"
            *         [yAxis]="yAxis"
            *         valueMemberPath="value"
            *         isDropShadowEnabled="true"
            *         shadowOffsetX="10"
            *         shadowOffsetY="10">
            *     </igx-column-series>
            * </igx-data-chart>
            * ```
            */
        function () {
            return this.i.et;
        },
        set: function (v) {
            this.i.et = +v;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgxSeriesComponent.prototype, "areaFillOpacity", {
        /**
         * Gets or sets the opacity applied to the area fill visual.
         * This property only applies to series that have area visual.
        *
        * ```html
        * <igx-data-chart #chart
        *     [dataSource]="data">
        *     <igx-category-x-axis
        *         label="label"
        *         #xAxis>
        *     </igx-category-x-axis>
        *     <igx-numeric-y-axis
        *         #yAxis>
        *     </igx-numeric-y-axis>
        *     <igx-area-series
        *         [xAxis]="xAxis"
        *         [yAxis]="yAxis"
        *         valueMemberPath="value"
        *         areaFillOpacity=.5>
        *     </igx-area-series>
        * </igx-data-chart>
        * ```
        */
        get: /**
             * Gets or sets the opacity applied to the area fill visual.
             * This property only applies to series that have area visual.
            *
            * ```html
            * <igx-data-chart #chart
            *     [dataSource]="data">
            *     <igx-category-x-axis
            *         label="label"
            *         #xAxis>
            *     </igx-category-x-axis>
            *     <igx-numeric-y-axis
            *         #yAxis>
            *     </igx-numeric-y-axis>
            *     <igx-area-series
            *         [xAxis]="xAxis"
            *         [yAxis]="yAxis"
            *         valueMemberPath="value"
            *         areaFillOpacity=.5>
            *     </igx-area-series>
            * </igx-data-chart>
            * ```
            */
        function () {
            return this.i.d3;
        },
        set: function (v) {
            this.i.d3 = +v;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgxSeriesComponent.prototype, "actualAreaFillOpacity", {
        /**
         * Gets the actual opacity applied to the area fill visual.
        */
        get: /**
             * Gets the actual opacity applied to the area fill visual.
            */
        function () {
            return this.i.d2;
        },
        set: function (v) {
            this.i.d2 = +v;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgxSeriesComponent.prototype, "isDefaultToolTipSelected", {
        /**
         * Gets if the default tooltip has been selected for display.
        *
        * To use the default tooltip set `showDefaultTooltip` to true.
        */
        get: /**
             * Gets if the default tooltip has been selected for display.
            *
            * To use the default tooltip set `showDefaultTooltip` to true.
            */
        function () {
            return this.i.co;
        },
        set: function (v) {
            this.i.co = ensureBool(v);
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgxSeriesComponent.prototype, "showDefaultTooltip", {
        /**
         * Gets or sets whether default tooltip will be shown.
        *
        * The default tooltips display all the information relevant to the particular series item (series title, data values, axis values etc.) and are styled to match the series' style. When using default tooltips, you should also set the series `title`.
        *
        * ```html
        * <igx-data-chart
        *     [dataSource]="data">
        *     <igx-category-x-axis
        *         label="label"
        *         #xAxis>
        *     </igx-category-x-axis>
        *     <igx-numeric-y-axis
        *         #yAxis>
        *     </igx-numeric-y-axis>
        *     <igx-column-series
        *         [xAxis]="xAxis"
        *         [yAxis]="yAxis"
        *         valueMemberPath="value"
        *         showDefaultTooltip="true"
        *         title="InStock Items">
        *     </igx-column-series>
        * </igx-data-chart>
        * ```
        */
        get: /**
             * Gets or sets whether default tooltip will be shown.
            *
            * The default tooltips display all the information relevant to the particular series item (series title, data values, axis values etc.) and are styled to match the series' style. When using default tooltips, you should also set the series `title`.
            *
            * ```html
            * <igx-data-chart
            *     [dataSource]="data">
            *     <igx-category-x-axis
            *         label="label"
            *         #xAxis>
            *     </igx-category-x-axis>
            *     <igx-numeric-y-axis
            *         #yAxis>
            *     </igx-numeric-y-axis>
            *     <igx-column-series
            *         [xAxis]="xAxis"
            *         [yAxis]="yAxis"
            *         valueMemberPath="value"
            *         showDefaultTooltip="true"
            *         title="InStock Items">
            *     </igx-column-series>
            * </igx-data-chart>
            * ```
            */
        function () {
            return this.i.db;
        },
        set: function (v) {
            this.i.db = ensureBool(v);
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgxSeriesComponent.prototype, "transitionInDuration", {
        /**
         * Gets or sets the duration of the current series's transition in morph.
        *
        * The `transitionInDuration` can be used with `IgxSeriesComponent` to cofigure the animation when a new datasource is loaded.
        *
        * ```html
        * <igx-data-chart
        *     [dataSource]="data">
        *     <igx-category-x-axis
        *         label="label"
        *         #xAxis>
        *     </igx-category-x-axis>
        *     <igx-numeric-y-axis
        *         #yAxis>
        *     </igx-numeric-y-axis>
        *     <igx-column-series
        *         [xAxis]="xAxis"
        *         [yAxis]="yAxis"
        *         valueMemberPath="value"
        *         transitionInMode="accordionFromBottom"
        *         isTransitionInEnabled=true
        *         transitionInSpeedType="indexScaled"
        *         transitionDuration=500
        *         transitionInDuration=500>
        *     </igx-column-series>
        * </igx-data-chart>
        * ```
        */
        get: /**
             * Gets or sets the duration of the current series's transition in morph.
            *
            * The `transitionInDuration` can be used with `IgxSeriesComponent` to cofigure the animation when a new datasource is loaded.
            *
            * ```html
            * <igx-data-chart
            *     [dataSource]="data">
            *     <igx-category-x-axis
            *         label="label"
            *         #xAxis>
            *     </igx-category-x-axis>
            *     <igx-numeric-y-axis
            *         #yAxis>
            *     </igx-numeric-y-axis>
            *     <igx-column-series
            *         [xAxis]="xAxis"
            *         [yAxis]="yAxis"
            *         valueMemberPath="value"
            *         transitionInMode="accordionFromBottom"
            *         isTransitionInEnabled=true
            *         transitionInSpeedType="indexScaled"
            *         transitionDuration=500
            *         transitionInDuration=500>
            *     </igx-column-series>
            * </igx-data-chart>
            * ```
            */
        function () {
            return this.i.ff;
        },
        set: function (v) {
            this.i.ff = +v;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgxSeriesComponent.prototype, "transitionInSpeedType", {
        /**
         * Gets or sets the duration of the current series's transition in morph.
        *
        * The `transitionInSpeedType` can be used with `IgxSeriesComponent` to cofigure the animation when a new datasource is loaded.
        *
        * ```html
        * <igx-data-chart
        *     [dataSource]="data">
        *     <igx-category-x-axis
        *         label="label"
        *         #xAxis>
        *     </igx-category-x-axis>
        *     <igx-numeric-y-axis
        *         #yAxis>
        *     </igx-numeric-y-axis>
        *     <igx-column-series
        *         [xAxis]="xAxis"
        *         [yAxis]="yAxis"
        *         valueMemberPath="value"
        *         transitionInMode="accordionFromBottom"
        *         isTransitionInEnabled=true
        *         transitionInSpeedType="indexScaled"
        *         transitionInDuration=500>
        *     </igx-column-series>
        * </igx-data-chart>
        * ```
        */
        get: /**
             * Gets or sets the duration of the current series's transition in morph.
            *
            * The `transitionInSpeedType` can be used with `IgxSeriesComponent` to cofigure the animation when a new datasource is loaded.
            *
            * ```html
            * <igx-data-chart
            *     [dataSource]="data">
            *     <igx-category-x-axis
            *         label="label"
            *         #xAxis>
            *     </igx-category-x-axis>
            *     <igx-numeric-y-axis
            *         #yAxis>
            *     </igx-numeric-y-axis>
            *     <igx-column-series
            *         [xAxis]="xAxis"
            *         [yAxis]="yAxis"
            *         valueMemberPath="value"
            *         transitionInMode="accordionFromBottom"
            *         isTransitionInEnabled=true
            *         transitionInSpeedType="indexScaled"
            *         transitionInDuration=500>
            *     </igx-column-series>
            * </igx-data-chart>
            * ```
            */
        function () {
            return this.i.bp;
        },
        set: function (v) {
            this.i.bp = ensureEnum(TransitionInSpeedType_$type, v);
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgxSeriesComponent.prototype, "mouseOverEnabled", {
        /**
         * Gets or sets the whether the chart reacts to mouse move events.
        */
        get: /**
             * Gets or sets the whether the chart reacts to mouse move events.
            */
        function () {
            return this.i.c5;
        },
        set: function (v) {
            this.i.c5 = ensureBool(v);
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgxSeriesComponent.prototype, "coercionMethods", {
        /**
         * Gets or sets the coercion methods to use when loading data from data sources.
         * Should be specified before setting any member paths, if being used. Setting it later
         * will not cause data to be reimported into the chart.
        *
        * ```html
        *  <igx-data-chart
        *       [dataSource]="data"
        *      >
        *       <igx-category-x-axis
        *         label="label"
        *         #xAxis>
        *       </igx-category-x-axis>
        *       <igx-numeric-y-axis
        *         #yAxis>
        *       </igx-numeric-y-axis>
        *       <igx-line-series
        *       [xAxis]="xAxis"
        *       [yAxis]="yAxis"
        *       valueMemberPath="value">
        *      </igx-line-series>
        *        <igx-line-series
        *         [xAxis]="xAxis"
        *         [yAxis]="yAxis"
        *         [coercionMethods]= cMethods
        *         valueMemberPath="value!ValueCoercion">
        *        </igx-line-series>
        *     </igx-data-chart>
        * ```
        *
        * &lt;-- position: content member-->
        */
        get: /**
             * Gets or sets the coercion methods to use when loading data from data sources.
             * Should be specified before setting any member paths, if being used. Setting it later
             * will not cause data to be reimported into the chart.
            *
            * ```html
            *  <igx-data-chart
            *       [dataSource]="data"
            *      >
            *       <igx-category-x-axis
            *         label="label"
            *         #xAxis>
            *       </igx-category-x-axis>
            *       <igx-numeric-y-axis
            *         #yAxis>
            *       </igx-numeric-y-axis>
            *       <igx-line-series
            *       [xAxis]="xAxis"
            *       [yAxis]="yAxis"
            *       valueMemberPath="value">
            *      </igx-line-series>
            *        <igx-line-series
            *         [xAxis]="xAxis"
            *         [yAxis]="yAxis"
            *         [coercionMethods]= cMethods
            *         valueMemberPath="value!ValueCoercion">
            *        </igx-line-series>
            *     </igx-data-chart>
            * ```
            *
            * &lt;-- position: content member-->
            */
        function () {
            return this.i.coercionMethods;
        },
        set: function (v) {
            this.i.coercionMethods = v;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgxSeriesComponent.prototype, "expectFunctions", {
        /**
         * Gets or sets whether the series should expect that properties in its items source may be functions that need to be
         * evaluated to yield their value. This defaults to false, as there will be a subtle performance impact to using this feature.
         * This value must be set before assigning an item's source to take effect.
        *
        * ```html
        * <igx-data-chart
        *     [dataSource]="data">
        *     <igx-category-x-axis
        *     label="label"
        *     #xAxis>
        *     </igx-category-x-axis>
        *     <igx-numeric-y-axis
        *     #yAxis>
        *     </igx-numeric-y-axis>
        *     <igx-line-series
        *     [xAxis]="xAxis"
        *     [yAxis]="yAxis"
        *     expectFunctions=true
        *     valueMemberPath="MyFunction">
        *     </igx-line-series>
        * </igx-data-chart>
        * ```
        */
        get: /**
             * Gets or sets whether the series should expect that properties in its items source may be functions that need to be
             * evaluated to yield their value. This defaults to false, as there will be a subtle performance impact to using this feature.
             * This value must be set before assigning an item's source to take effect.
            *
            * ```html
            * <igx-data-chart
            *     [dataSource]="data">
            *     <igx-category-x-axis
            *     label="label"
            *     #xAxis>
            *     </igx-category-x-axis>
            *     <igx-numeric-y-axis
            *     #yAxis>
            *     </igx-numeric-y-axis>
            *     <igx-line-series
            *     [xAxis]="xAxis"
            *     [yAxis]="yAxis"
            *     expectFunctions=true
            *     valueMemberPath="MyFunction">
            *     </igx-line-series>
            * </igx-data-chart>
            * ```
            */
        function () {
            return this.i.expectFunctions;
        },
        set: function (v) {
            this.i.expectFunctions = ensureBool(v);
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgxSeriesComponent.prototype, "hitTestMode", {
        /**
         * Method of hit testing to use when pointing to items in this series.
        *
        * The `hitTestMode` can be set to either:
        *
        * -   `IgxSeriesComponent`: automatically decide the appropriate hit test mode for the series.
        * -   `IgxSeriesComponent`: use a color encoded off screen buffer for hit testing. Should always be O(1) time for determining a hit series. This increases frame render time and memory usage, however. Consider using this if hit testing time is degrading performance.
        * -   `IgxSeriesComponent`: use a computational based approach to determine whether the series has been hit. This uses loose bounding boxes, in some cases, and can range in time complexity between O(1) and O(log n) to find a hit. This decreases frame render time compared to color encoded
        */
        get: /**
             * Method of hit testing to use when pointing to items in this series.
            *
            * The `hitTestMode` can be set to either:
            *
            * -   `IgxSeriesComponent`: automatically decide the appropriate hit test mode for the series.
            * -   `IgxSeriesComponent`: use a color encoded off screen buffer for hit testing. Should always be O(1) time for determining a hit series. This increases frame render time and memory usage, however. Consider using this if hit testing time is degrading performance.
            * -   `IgxSeriesComponent`: use a computational based approach to determine whether the series has been hit. This uses loose bounding boxes, in some cases, and can range in time complexity between O(1) and O(log n) to find a hit. This decreases frame render time compared to color encoded
            */
        function () {
            return this.i.be;
        },
        set: function (v) {
            this.i.be = ensureEnum(SeriesHitTestMode_$type, v);
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgxSeriesComponent.prototype, "actualHitTestMode", {
        /**
         * Resolved method of hit testing to use when pointing to items in the chart.
        */
        get: /**
             * Resolved method of hit testing to use when pointing to items in the chart.
            */
        function () {
            return this.i.bc;
        },
        set: function (v) {
            this.i.bc = ensureEnum(SeriesHitTestMode_$type, v);
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgxSeriesComponent.prototype, "isNegativeColorSupported", {
        /**
         * Overridden by derived series classes to indicate when negative colors are supported or not.
        */
        get: /**
             * Overridden by derived series classes to indicate when negative colors are supported or not.
            */
        function () {
            return this.i.cz;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgxSeriesComponent.prototype, "isMarkerlessDisplayPreferred", {
        /**
         * Overridden by derived series classes to indicate when markerless display is preferred or not.
        */
        get: /**
             * Overridden by derived series classes to indicate when markerless display is preferred or not.
            */
        function () {
            return this.i.cy;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgxSeriesComponent.prototype, "finalValue", {
        /**
         * The final value of this series.
        */
        get: /**
             * The final value of this series.
            */
        function () {
            return this.i.d4;
        },
        set: function (v) {
            this.i.d4 = +v;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgxSeriesComponent.prototype, "percentChange", {
        /**
         * The percent change from the beginning to the end of this series.
        */
        get: /**
             * The percent change from the beginning to the end of this series.
            */
        function () {
            return this.i.ep;
        },
        set: function (v) {
            this.i.ep = +v;
        },
        enumerable: true,
        configurable: true
    });
    /**
 * Gets the brush for tooltip labels.

*/
    /**
         * Gets the brush for tooltip labels.
        
        */
    IgxSeriesComponent.prototype.resolveTooltipBrush = /**
         * Gets the brush for tooltip labels.
        
        */
    function () {
        var iv = this.i.go();
        return (iv);
    };
    /**
     * Gets the precise item index, if possible, based on the closeness to the previous or next whole integer. If the series cannot provide this information, GetExactItemIndex will return the same integer value as GetItemIndex.
    
    * @param world  * The world position for which to return the index.
    */
    /**
         * Gets the precise item index, if possible, based on the closeness to the previous or next whole integer. If the series cannot provide this information, GetExactItemIndex will return the same integer value as GetItemIndex.
        
        * @param world  * The world position for which to return the index.
        */
    IgxSeriesComponent.prototype.getExactItemIndex = /**
         * Gets the precise item index, if possible, based on the closeness to the previous or next whole integer. If the series cannot provide this information, GetExactItemIndex will return the same integer value as GetItemIndex.
        
        * @param world  * The world position for which to return the index.
        */
    function (world) {
        var iv = this.i.d7(toPoint(world));
        return (iv);
    };
    /**
     * Gets the item item index associated with the specified world position
    
    */
    /**
         * Gets the item item index associated with the specified world position
        
        */
    IgxSeriesComponent.prototype.getItemIndex = /**
         * Gets the item item index associated with the specified world position
        
        */
    function (world) {
        var iv = this.i.e4(toPoint(world));
        return (iv);
    };
    /**
     * Gets the item that is the best match for the specified world coordinates.
    
    * @param world  * The world coordinates to use.
    */
    /**
         * Gets the item that is the best match for the specified world coordinates.
        
        * @param world  * The world coordinates to use.
        */
    IgxSeriesComponent.prototype.getItem = /**
         * Gets the item that is the best match for the specified world coordinates.
        
        * @param world  * The world coordinates to use.
        */
    function (world) {
        var iv = this.i.fl(toPoint(world));
        return (iv);
    };
    IgxSeriesComponent.prototype.getPreviousOrExactIndex = function (world, skipUnknowns) {
        var iv = this.i.fa(toPoint(world), skipUnknowns);
        return (iv);
    };
    IgxSeriesComponent.prototype.getNextOrExactIndex = function (world, skipUnknowns) {
        var iv = this.i.e8(toPoint(world), skipUnknowns);
        return (iv);
    };
    IgxSeriesComponent.prototype.getSeriesValue = function (world, useInterpolation, skipUnknowns) {
        var iv = this.i.ej(toPoint(world), useInterpolation, skipUnknowns);
        return (iv);
    };
    IgxSeriesComponent.prototype.getSeriesValuePosition = function (world, useInterpolation, skipUnknowns) {
        var iv = this.i.lc(toPoint(world), useInterpolation, skipUnknowns);
        return fromPoint(iv);
    };
    /**
     * If possible, will return the best available value bounding box within the series that has the best value match for the world position provided.
    
    * @param world  * The world coordinate for which to get a value bounding box for
    */
    /**
         * If possible, will return the best available value bounding box within the series that has the best value match for the world position provided.
        
        * @param world  * The world coordinate for which to get a value bounding box for
        */
    IgxSeriesComponent.prototype.getSeriesValueBoundingBox = /**
         * If possible, will return the best available value bounding box within the series that has the best value match for the world position provided.
        
        * @param world  * The world coordinate for which to get a value bounding box for
        */
    function (world) {
        var iv = this.i.ll(toPoint(world));
        return fromRect(iv);
    };
    /**
     * If possible, will return the best available value marker bounding box within the series that has the best value match for the world position provided.
    
    * @param world  * The world coordinates for which to get a value marker bounding box for
    */
    /**
         * If possible, will return the best available value marker bounding box within the series that has the best value match for the world position provided.
        
        * @param world  * The world coordinates for which to get a value marker bounding box for
        */
    IgxSeriesComponent.prototype.getSeriesValueMarkerBoundingBox = /**
         * If possible, will return the best available value marker bounding box within the series that has the best value match for the world position provided.
        
        * @param world  * The world coordinates for which to get a value marker bounding box for
        */
    function (world) {
        var iv = this.i.ln(toPoint(world));
        return fromRect(iv);
    };
    IgxSeriesComponent.prototype.getSeriesHighValue = function (world, useInterpolation, skipUnknowns) {
        var iv = this.i.ef(toPoint(world), useInterpolation, skipUnknowns);
        return (iv);
    };
    IgxSeriesComponent.prototype.getSeriesHighValuePosition = function (world, useInterpolation, skipUnknowns) {
        var iv = this.i.k8(toPoint(world), useInterpolation, skipUnknowns);
        return fromPoint(iv);
    };
    IgxSeriesComponent.prototype.getSeriesLowValue = function (world, useInterpolation, skipUnknowns) {
        var iv = this.i.eh(toPoint(world), useInterpolation, skipUnknowns);
        return (iv);
    };
    IgxSeriesComponent.prototype.getSeriesLowValuePosition = function (world, useInterpolation, skipUnknowns) {
        var iv = this.i.la(toPoint(world), useInterpolation, skipUnknowns);
        return fromPoint(iv);
    };
    IgxSeriesComponent.prototype.getSeriesValuePositionFromSeriesPixel = function (mouse, useInterpolation, skipUnknowns) {
        var iv = this.i.ld(toPoint(mouse), useInterpolation, skipUnknowns);
        return fromPoint(iv);
    };
    IgxSeriesComponent.prototype.getSeriesValueFromSeriesPixel = function (mouse, useInterpolation, skipUnknowns) {
        var iv = this.i.ek(toPoint(mouse), useInterpolation, skipUnknowns);
        return (iv);
    };
    /**
     * For a category plotted series, returns the current width of the items within the categories. This only returns a value if the items have some form of width (e.g. columns, bars, etc.) otherwise 0 is returned.
    
    */
    /**
         * For a category plotted series, returns the current width of the items within the categories. This only returns a value if the items have some form of width (e.g. columns, bars, etc.) otherwise 0 is returned.
        
        */
    IgxSeriesComponent.prototype.getItemSpan = /**
         * For a category plotted series, returns the current width of the items within the categories. This only returns a value if the items have some form of width (e.g. columns, bars, etc.) otherwise 0 is returned.
        
        */
    function () {
        var iv = this.i.ec();
        return (iv);
    };
    /**
     * Converts a point from coordinates within the series plot area to a world position within axis space.
    
    * @param seriesPoint  * The pixel location within the plot area of the series.
    */
    /**
         * Converts a point from coordinates within the series plot area to a world position within axis space.
        
        * @param seriesPoint  * The pixel location within the plot area of the series.
        */
    IgxSeriesComponent.prototype.toWorldPosition = /**
         * Converts a point from coordinates within the series plot area to a world position within axis space.
        
        * @param seriesPoint  * The pixel location within the plot area of the series.
        */
    function (seriesPoint) {
        var iv = this.i.lf(toPoint(seriesPoint));
        return fromPoint(iv);
    };
    /**
     * Converts a point from world coordinates to coordinates within the viewport of the series.
    
    * @param world  * The world position from which to convert.
    */
    /**
         * Converts a point from world coordinates to coordinates within the viewport of the series.
        
        * @param world  * The world position from which to convert.
        */
    IgxSeriesComponent.prototype.fromWorldPosition = /**
         * Converts a point from world coordinates to coordinates within the viewport of the series.
        
        * @param world  * The world position from which to convert.
        */
    function (world) {
        var iv = this.i.k7(toPoint(world));
        return fromPoint(iv);
    };
    /**
     * Requests that the provided item should be brought into view if possible.
    
    * @param item  * The item to attempt to bring into view.
    */
    /**
         * Requests that the provided item should be brought into view if possible.
        
        * @param item  * The item to attempt to bring into view.
        */
    IgxSeriesComponent.prototype.scrollIntoView = /**
         * Requests that the provided item should be brought into view if possible.
        
        * @param item  * The item to attempt to bring into view.
        */
    function (item) {
        var iv = this.i.c7(item);
        return (iv);
    };
    /**
     * Renders the series.
    
    * @param animate  * True if the change should be animated.
    */
    /**
         * Renders the series.
        
        * @param animate  * True if the change should be animated.
        */
    IgxSeriesComponent.prototype.renderSeries = /**
         * Renders the series.
        
        * @param animate  * True if the change should be animated.
        */
    function (animate) {
        this.i.i4(animate);
    };
    /**
     * Gets the effective viewport, adjusted to account for margins and other factors.
    
    */
    /**
         * Gets the effective viewport, adjusted to account for margins and other factors.
        
        */
    IgxSeriesComponent.prototype.getEffectiveViewport = /**
         * Gets the effective viewport, adjusted to account for margins and other factors.
        
        */
    function () {
        var iv = this.i.getEffectiveViewport();
        return fromRect(iv);
    };
    /**
     * Removes all alternate views of this series.
    
    */
    /**
         * Removes all alternate views of this series.
        
        */
    IgxSeriesComponent.prototype.removeAllAlternateViews = /**
         * Removes all alternate views of this series.
        
        */
    function () {
        this.i.iz();
    };
    /**
     * Removes an alternate view of this series.
    
    * @param viewIdentifier  * The string identifier for the view to remove.
    */
    /**
         * Removes an alternate view of this series.
        
        * @param viewIdentifier  * The string identifier for the view to remove.
        */
    IgxSeriesComponent.prototype.removeAlternateView = /**
         * Removes an alternate view of this series.
        
        * @param viewIdentifier  * The string identifier for the view to remove.
        */
    function (viewIdentifier) {
        this.i.i1(viewIdentifier);
    };
    /**
     * Replays the assigned transition in animation, if any.
    
    */
    /**
         * Replays the assigned transition in animation, if any.
        
        */
    IgxSeriesComponent.prototype.replayTransitionIn = /**
         * Replays the assigned transition in animation, if any.
        
        */
    function () {
        this.i.i7();
    };
    /**
     * Simulates a pointer hover over the series surface.
    
    * @param point  * The pointer position relative to the series viewport over which to hover.
    *
    * When tooltips are enabled, `simulateHover` can be used to automatically display the tooltip over a particular series item.
    */
    /**
         * Simulates a pointer hover over the series surface.
        
        * @param point  * The pointer position relative to the series viewport over which to hover.
        *
        * When tooltips are enabled, `simulateHover` can be used to automatically display the tooltip over a particular series item.
        */
    IgxSeriesComponent.prototype.simulateHover = /**
         * Simulates a pointer hover over the series surface.
        
        * @param point  * The pointer position relative to the series viewport over which to hover.
        *
        * When tooltips are enabled, `simulateHover` can be used to automatically display the tooltip over a particular series item.
        */
    function (point) {
        this.i.jb(toPoint(point));
    };
    /**
     * Called when this series' Style is updated.
    
    */
    /**
         * Called when this series' Style is updated.
        
        */
    IgxSeriesComponent.prototype.styleUpdated = /**
         * Called when this series' Style is updated.
        
        */
    function () {
        this.i.jd();
    };
    IgxSeriesComponent.prototype.setNegativeColors = function (negativeBrush, negativeOutline) {
        this.i.i9(stringToBrush(negativeBrush), stringToBrush(negativeOutline));
    };
    /**
     * Moves the cursor point to the provided world position. Some series may react to the current cursor position.
    
    * @param point  * The cursor point, in world coordinates.
    *
    * `moveCursorPoint` can be used on annotation layers to programitically show the annotation at the given point.
    */
    /**
         * Moves the cursor point to the provided world position. Some series may react to the current cursor position.
        
        * @param point  * The cursor point, in world coordinates.
        *
        * `moveCursorPoint` can be used on annotation layers to programitically show the annotation at the given point.
        */
    IgxSeriesComponent.prototype.moveCursorPoint = /**
         * Moves the cursor point to the provided world position. Some series may react to the current cursor position.
        
        * @param point  * The cursor point, in world coordinates.
        *
        * `moveCursorPoint` can be used on annotation layers to programitically show the annotation at the given point.
        */
    function (point) {
        this.i.h4(toPoint(point));
    };
    Object.defineProperty(IgxSeriesComponent.prototype, "renderRequested", {
        get: /**
             * This event is raised every time a render has been requested from a series.
            */
        function () {
            var _this = this;
            if (this._renderRequested == null) {
                this._renderRequested = new EventEmitter();
                this.i.renderRequested = delegateCombine(this.i.renderRequested, function (o, e) {
                    var outerArgs = new RenderRequestedEventArgs();
                    outerArgs._provideImplementation(e);
                    _this._renderRequested.emit({
                        sender: _this,
                        args: outerArgs
                    });
                });
            }
            return this._renderRequested;
        },
        enumerable: true,
        configurable: true
    });
    IgxSeriesComponent.prototype._runInZone = function (act) {
        if (this._zoneRunner != null) {
            this._zoneRunner(act);
        }
        else {
            act();
        }
    };
    IgxSeriesComponent.propDecorators = {
        "name": [{ type: Input },],
        "dataSource": [{ type: Input },],
        "tooltipTemplate": [{ type: Input },],
        "tooltipContainerTemplate": [{ type: Input },],
        "legendItemVisibility": [{ type: Input },],
        "legendItemBadgeTemplate": [{ type: Input },],
        "legendItemTemplate": [{ type: Input },],
        "discreteLegendItemTemplate": [{ type: Input },],
        "transitionEasingFunction": [{ type: Input },],
        "transitionInEasingFunction": [{ type: Input },],
        "transitionDuration": [{ type: Input },],
        "resolution": [{ type: Input },],
        "title": [{ type: Input },],
        "brush": [{ type: Input },],
        "actualBrush": [{ type: Input },],
        "outline": [{ type: Input },],
        "actualOutline": [{ type: Input },],
        "thickness": [{ type: Input },],
        "isHighlightingEnabled": [{ type: Input },],
        "isDropShadowEnabled": [{ type: Input },],
        "shadowBlur": [{ type: Input },],
        "shadowColor": [{ type: Input },],
        "useSingleShadow": [{ type: Input },],
        "shadowOffsetX": [{ type: Input },],
        "shadowOffsetY": [{ type: Input },],
        "areaFillOpacity": [{ type: Input },],
        "actualAreaFillOpacity": [{ type: Input },],
        "isDefaultToolTipSelected": [{ type: Input },],
        "showDefaultTooltip": [{ type: Input },],
        "transitionInDuration": [{ type: Input },],
        "transitionInSpeedType": [{ type: Input },],
        "mouseOverEnabled": [{ type: Input },],
        "coercionMethods": [{ type: Input },],
        "expectFunctions": [{ type: Input },],
        "hitTestMode": [{ type: Input },],
        "actualHitTestMode": [{ type: Input },],
        "finalValue": [{ type: Input },],
        "percentChange": [{ type: Input },],
        "renderRequested": [{ type: Output },],
    };
    return IgxSeriesComponent;
}());
export { IgxSeriesComponent };
//# sourceMappingURL=igx-series-component.js.map